<?php 
global $WPrapAjaxEditComments;
if (!isset($WPrapAjaxEditComments)) { //for wp-load.php
	include('plugin-checker.php');
}
//Check the nonce
if (isset($_GET['cid'])) {
	check_admin_referer('requestdeletion_' . (int)$_GET['cid']);
}
$commentID = (int)$_GET['cid'];
$postID = (int)$_GET['pid'];
$commentAction = $_GET['action'];
$commentAction = addslashes(preg_replace("/[^a-z0-9]/i", '', strip_tags($commentAction))); 
$options = $WPrapAjaxEditComments->adminOptions;
$localization = $WPrapAjaxEditComments->localizationName;
$min = '';
if ($options['compressed_scripts'] == 'true') {
	$min = ".min";
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<?php 
wp_enqueue_script("wp-ajax-response");
wp_enqueue_script('jquery'); 
$WPrapAjaxEditComments->js_localize('wpajaxeditcommentedit',$WPrapAjaxEditComments->get_js_vars($postID));
wp_enqueue_script('wp_ajax_request_deletion', $WPrapAjaxEditComments->pluginDir . "/js/request-deletion$min.js", array("jquery", "wp-ajax-response") , 2.3);
?>
<?php 
switch ($options['icon_set']) {
	case "aesthetica-large":
	case "classy-large":
	case "shadow":
	case "moi":
		$iconSize = 24;
		break;
	default:
		$iconSize = 16;
		break;
}
wp_enqueue_style('aeccommenteditor', $WPrapAjaxEditComments->pluginDir.'/css/comment-editor.css.php?iconsize='.$iconSize.'&iconset='.$options['icon_set'].'&rtl='.$options['use_rtl'].'&icondisplay='.$options['icon_display'], array(), '4.1');
$afterthedeadline = ($options['after_deadline'] == "true" && WPLANG == '' ? true : false);
//Enable after the deadline for english only
if ($afterthedeadline) {
	wp_enqueue_script('atd', $WPrapAjaxEditComments->pluginDir . "/js/jquery.atd.textarea.js", array("jquery") , "1.0");
	wp_enqueue_script('atd_hack', $WPrapAjaxEditComments->pluginDir . '/js/csshttprequest.js', array('atd'), '1.0');
	wp_enqueue_style('atd', $WPrapAjaxEditComments->pluginDir.'/css/atd/atd.css', array(), '4.1');
} 
wp_print_scripts(array('wp_ajax_request_deletion','atd', 'atd_hack'));
wp_print_styles(array('aeccommenteditor', 'atd'));
do_action('add_wp_ajax_comments_css_editor');
?>
<title>WP Ajax Edit Comments Request Deletion</title>
</head>
<body>
<div id="comment-options">
<h3><?php _e("Request Deletion", $localization); ?></h3>
<?php 
/* Admin nonce */
	wp_nonce_field('wp-ajax-edit-comments_request-deletion');
?>
<div><input type="hidden" id="commentID" value="<?php echo $commentID;?>" />
  <input type="hidden" id="postID" value="<?php echo $postID;?>" />
  <input type="hidden" id="action" value="<?php echo $commentAction;?>" /></div>
  	<table class="form inputs">
    <tbody>
    	<tr>
      <td>
      <?php _e('Please explain why the comment should be deleted.  After sending the request, your comment will be marked as moderated and will no longer be viewable publicly.',$localization); ?>
      </td>
      <tr>
        <td><textarea cols="70" rows="8" name="deletion-reason" id="deletion-reason"></textarea></td>
      </tr>
    </tbody>
    </table>
<div class="form" id="buttons">
	<div><input type="button" id="send-request" name="send-request" value="<?php _e('Send Request',$localization); ?>" /></div>
  <div><input type="button" name="cancel" id="cancel" value="<?php _e('Cancel',$localization); ?>" /></div>
</div>
<div id="status"><span id="message"></span><span id="close-option">&nbsp;-&nbsp;<a href="#"><?php _e('Close',$localization); ?></a></span></div>
</div> <!-- end comment options-->
</body>
</html>
