<?php
/*
Plugin Name: WP Ajax Edit Comments
Plugin URI: http://www.ajaxeditcomments.com/
Description: The most powerful comment-editing solution for WordPress.  Users can edit their own comments for a limited time, while admins can edit all comments.
Author: Ajay D'Souza, Ronald Huereca
Version: 4.1.8.3
Requires at least: 3.0
Author URI: http://www.ajaxeditcomments.com/
Generated At: www.wp-fun.co.uk;
Upgrade code courtesy of Gravity Forms
*/ 

if (!class_exists('WPrapAjaxEditComments')) {
    class WPrapAjaxEditComments	{		
		var $commentClassName = "edit-comment"; 
		var $authorClassName = "edit-author";
		var $cookieName = "WPAjaxEditCommentsComment"; /*Please do not edit these variables*/
		var $adminOptionsName = "WPAjaxEditComments20";
		var $userOptionsName = "WPAjaxEditAuthorUserOptions";
		var $localizationName = "ajaxEdit";
		var $minutes = 5;
		var $version = "4.1.8.3";
		var $has_set_option = false;
     	var $has_set_transient = false;
		var $aec_url = "http://www.ajaxeditcomments.com/forums/my-plugins/aec";
		/**
		* PHP 4 Compatible Constructor
		*/
		function WPrapAjaxEditComments(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){
			$this->adminOptions = $this->get_admin_options();
			$this->pluginDir = plugins_url('wp-ajax-edit-comments');
			
			//When a comment is posted
			add_action('comment_post', array(&$this, 'comment_posted'),100,1);
			
			//Custom actions for other plugin authors
			add_action('add_wp_ajax_comments_js_post', array(&$this,'add_post_scripts'));
			add_action('add_wp_ajax_comments_js_admin', array(&$this,'add_post_scripts'));
			add_action('wp_ajax_comments_comment_edited', array(&$this, 'edit_notification'),1,2);
			add_action('wp_ajax_comments_comment_edited', array(&$this, 'comment_edited'),2,2);
			add_action('wp_ajax_comments_remove_content_filter', array(&$this, 'comment_filter'));
			
			
			add_action('init', array(&$this, 'init'));
			
			
			//For disabling trackbacks/pingbacks
			if ($this->adminOptions['disable_trackbacks'] == 'true') {
				add_filter('comments_array', array(&$this,"filter_trackbacks"), 0);
				add_filter('get_comments_number', array(&$this,'filter_comments_number'));
			}
			
			//For disabling no-follow on links
			if ($this->adminOptions['disable_nofollow'] == 'true') {
				add_filter('get_comment_author_link', array(&$this, 'remove_nofollow'));
				add_filter('comment_text', array(&$this, 'remove_nofollow'));
				add_filter('thesis_comment_text', array(&$this, 'remove_nofollow')); //For Thesis (todo - remove when necessary)
			}
			
			//For disabling self-pings
			if ($this->adminOptions['disable_selfpings'] == 'true') {
				add_action( 'pre_ping', array(&$this,'disable_selfpings'));
			}
			
			//For the plugin settings link
			add_filter('plugin_action_links_' . plugin_basename(__FILE__)
, array(&$this, 'add_settings_link'), -10);
			
		} //end constructor
		/* add_author_spans - Adds spans to author links */
		function add_author_spans($content) {
			global $comment;
			if ($this->skip) { $this->skip = false; return $content; }
			if (empty($comment)) { return $content; }
			if ($this->can_edit_quickcheck($comment) != 1) { return $content; } //--ag
			if ($this->can_edit($comment->comment_ID, $comment->comment_post_ID) != 1) { return $content; }
			$content = "<span id='$this->authorClassName" . "$comment->comment_ID'>$content</span>";
			return $content;
		}
		/* add_date_spans - Adds spans to date links */
		function add_date_spans($content) {
			global $comment;
			if ($this->skip) { $this->skip = false; return $content; }
			if (empty($comment)) { return $content; }
			if ($this->can_edit_quickcheck($comment) != 1) { return $content; } //--ag
			if ($this->can_edit($comment->comment_ID, $comment->comment_post_ID) != 1) { return $content; }
			$content = "<span id='aecdate$comment->comment_ID'>$content</span>";
			return $content;
		}
		/* add_edit_links - Adds edit links to post and admin panels */
		function add_edit_links($content) {
			global $comment;
			if ($this->skip) { $this->skip = false; return $content; }
			if (empty($comment)) { return $content; }
			if (is_page() && $this->adminOptions['show_pages'] != 'true') {
				return $content;
			}
			if ($this->can_edit_quickcheck($comment) != 1) { return $content; } //--ag
			if ($this->can_edit($comment->comment_ID, $comment->comment_post_ID) != 1) { return $content; }
			
			if ($this->adminOptions['comment_display_top'] == 'true') {
				$aec_top = true;
			}
			$tempContent = $content; //temporary variable to store content
			$edit_admin = "edit-comment-admin-links";
			$clearfix=$timer_class='';
			if ($this->adminOptions['icon_display'] != 'classic' && $this->adminOptions['icon_display'] != 'dropdown') {
					$edit_admin = "edit-comment-admin-links-no-icon";	
					$timer_class = "ajax-edit-time-left-no-icon";
			}
			/*If you're wondering why the JS is inline, it's because people with 500+ comments were having their browsers lock up.  With inline, the JS is run as needed.  Not elegant, but the best solution.*/
			if (!isset($aec_top)) { //Test to see if user wants interface on top or bottom
				$content = '<div class="'.$this->commentClassName. '" id="' . $this->commentClassName . $comment->comment_ID . '" style="background: none">' . $content .  '</div>';
				$content .= "<div id='comment-undo-$comment->comment_ID' class='aec-undo' style='background: none'></div>";
			} else {
				$content = '';
			}
			if (!$this->is_comment_owner($comment->comment_post_ID)) {
				//For anonymous users
				$content .= "<div class='$edit_admin $clearfix' id='edit-comment-user-link-$comment->comment_ID' style='background:none'>";
				
				$content .= $this->build_admin_links($comment->comment_ID, $comment->comment_post_ID);
				$content .= "</div>";
				//Show custom content to users
				if ($this->show_affiliate_link()) {
					$message .= do_shortcode(stripslashes($this->adminOptions['affiliate_text']));
					$message = str_replace("[url]", "<a href='http://www.ajaxeditcomments.com/?affiliate_id=" . $this->adminOptions['affiliate_id'] . "'>",$message);
					$message = str_replace("[/url]", "</a>", $message);
					$content .= "<div class='aec-custom-text'>$message</div><!--/aec-custom-text-->";
				}
				//End for anonymous users
			} else {
				$options = $this->get_user_options();
				//Check if user is editor
				$role = $this->get_user_role();
				if ($role == 'editor' && $this->adminOptions['allow_editing_editors'] == 'false')
					return $content;
				if (is_admin() && $options['admin_editing'] == "false") { 
					//We're in the admin panel
					$content .= '<div class="' .$edit_admin. ' ' . $clearfix.'" id="' . $this->commentClassName . '-admin-links' . $comment->comment_ID . '">';
					$content .= $this->build_admin_links($comment->comment_ID, $comment->comment_post_ID);
					$content .= "</div>";
					//End in the admin panel
				} elseif ($options['comment_editing'] == "true") { 
					//We're in a post
					$content .= '<div class="' . $edit_admin . ' ' . $clearfix . '" id="' . $this->commentClassName . '-admin-links' . $comment->comment_ID . '" style="background: none">';
					$content .= $this->build_admin_links($comment->comment_ID, $comment->comment_post_ID);
					$content .= "</div>";
				}
				
			}
			if (isset($aec_top)) { //Test to see if user wants interface on top or bottom
				$content .= "<div id='comment-undo-$comment->comment_ID' class='aec-undo' style='background: none'></div>";
				$content .= '<div class="'.$this->commentClassName. '" id="' . $this->commentClassName . $comment->comment_ID . '" style="background: none">' . $tempContent .  '</div>';
			}
			
			return $content;
			
		} //end function add_edit_links
		//Add a settings link to the plugin's page
		function add_settings_link($links) {
			array_push($links, sprintf('<a href="admin.php?page=wpaec">%s</a>', __("Settings", $this->localizationName)));
			return $links;
		}
		/* add_date_spans - Adds spans to date links */
		function add_time_spans($content) {
			global $comment;
			if (empty($comment)) { return $content; }
			if ($this->can_edit_quickcheck($comment) != 1) { return $content; } //--ag
			if ($this->can_edit($comment->comment_ID, $comment->comment_post_ID) != 1) { return $content; }
			$content = "<span id='aectime$comment->comment_ID'>$content</span>";
			return $content;
		}
		/*add_query_triggers - Adds multiple triggers for the various overlays and Ajax processor*/
		function add_query_triggers($queries) {
			array_push($queries, 'aec_page');
			return $queries;
		}
		/* approve_comment - Marks a comment as approved 
		Parameters - $commentID, $postID
		Returns - 1 if successful, a string error message if not */
		function approve_comment($commentID=0, $postID = 0) {
			if ($this->is_comment_owner($postID)) {
				$status = wp_set_comment_status($commentID, 'approve')? "1" : 'approve_failed';
				return $status;
			} else {
				return 'approve_failed_permission';
			}
		}
		function build_admin_links($commentID, $postID, $content = '') {
			$comment = get_comment($commentID);
			$ajax_url = get_bloginfo('url') . "/?aec_page=ajax-processor.php&";
			$plugin_url = plugins_url('wp-ajax-edit-comments') . '/php/';
			if ($this->adminOptions['use_wpload'] == 'true')
				$ajax_url = plugins_url('wp-ajax-edit-comments') . '/php/ajax-processor.php?';
			if (!$this->is_comment_owner($postID)) {
				$edit_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=comment-editor.php&action=editcomment&cid=$commentID&pid=$postID", "editcomment_$commentID")."&height=435&width=560");
				if ($this->adminOptions['use_wpload'] == 'true')
					$edit_url = clean_url(wp_nonce_url($plugin_url . "comment-editor.php?action=editcomment&cid=$commentID&pid=$postID", "editcomment_$commentID")."&height=435&width=560");
			} else {
				$edit_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=comment-editor.php&action=editcomment&cid=$commentID&pid=$postID", "editcomment_$commentID")."&height=525&width=620");
				if ($this->adminOptions['use_wpload'] == 'true')
					$edit_url = clean_url(wp_nonce_url($plugin_url . "comment-editor.php?action=editcomment&cid=$commentID&pid=$postID", "editcomment_$commentID")."&height=525&width=620");
			}
			$move_comment_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=move-comment.php&action=movecomment&pid=$postID&cid=$commentID", "movecomment_$commentID")."&height=500&width=560");
			if ($this->adminOptions['use_wpload'] == 'true')
					$move_comment_url = clean_url(wp_nonce_url($plugin_url . "move-comment.php?action=movecomment&pid=$postID&cid=$commentID", "movecomment_$commentID")."&height=500&width=560");
			$request_deletion_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=request-deletion.php&action=requestdeletion&pid=$postID&cid=$commentID", "requestdeletion_$commentID")."&height=495&width=560");
			if ($this->adminOptions['use_wpload'] == 'true')
					$request_deletion_url = clean_url(wp_nonce_url($plugin_url . "request-deletion.php?action=requestdeletion&pid=$postID&cid=$commentID", "requestdeletion_$commentID")."&height=495&width=560");
			$request_delete_url = clean_url( wp_nonce_url( $ajax_url . "action=requestdeletecomment&pid=$postID&cid=$commentID", "requestdeletecomment_$commentID" ) );
			$spam_url = clean_url( wp_nonce_url( $ajax_url . "action=spamcomment&pid=$postID&cid=$commentID", "spamcomment_$commentID" ) );
			$admin_email = get_bloginfo('admin_email');
			$commenter_email = $comment->comment_author_email;
			$email_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=email.php&action=email&admin=$admin_email&commenter=$commenter_email&pid=$postID&cid=$commentID", "email_$commentID")."&height=500&width=600");
			if ($this->adminOptions['use_wpload'] == 'true')
					$email_url = clean_url(wp_nonce_url($plugin_url . "email.php?action=email&admin=$admin_email&commenter=$commenter_email&pid=$postID&cid=$commentID", "email_$commentID")."&height=500&width=600");
			$blacklist_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=blacklist-comment.php&action=blacklist&pid=$postID&cid=$commentID", "blacklist_$commentID")."&height=550&width=600");
			if ($this->adminOptions['use_wpload'] == 'true')
					$blacklist_url = clean_url(wp_nonce_url($plugin_url . "blacklist-comment.php?action=blacklist&pid=$postID&cid=$commentID", "blacklist_$commentID")."&height=550&width=600");
			$delete_url = clean_url( wp_nonce_url( $ajax_url . "action=deletecomment&pid=$postID&cid=$commentID", "deletecomment_$commentID" ) );
			$restore_url = clean_url( wp_nonce_url( $ajax_url . "action=undodelete&pid=$postID&cid=$commentID", "undodelete_$commentID" ) );
			$deleteperm_url = clean_url( wp_nonce_url( $ajax_url . "action=deleteperm&pid=$postID&cid=$commentID", "deleteperm_$commentID" ) );
			$moderate_url = clean_url( wp_nonce_url( $ajax_url . "action=unapprovecomment&pid=$postID&cid=$commentID", "unapprovecomment_$commentID" ) );
			$approve_url = clean_url( wp_nonce_url( $ajax_url . "action=approvecomment&pid=$postID&cid=$commentID", "approvecomment_$commentID" ) );
			$delink_url = clean_url( wp_nonce_url( $ajax_url . "action=delinkcomment&pid=$postID&cid=$commentID", "delinkcomment_$commentID" ) );
			//Icon Classes
			$spam_class=$moderate_class=$edit_class=$approve_class=$delete_class=$clearfix=$timer_class='';
			$edit_admin = "edit-comment-admin-links";
			if ($this->adminOptions['icon_display'] != 'noicons') {
					$spam_class = 'spam-comment';
					$moderate_class = 'moderate-comment';
					$edit_class = 'edit-comment';
					$request_deletion_class = "request-deletion-comment";
					$approve_class = 'approve-comment';
					$delete_class = 'delete-comment';
					$delink_class = 'delink-comment';
					$move_class = "move-comment";			
					$blacklist_class = "blacklist-comment";
					$email_class = "email-comment";
			} else {
				$edit_admin = "edit-comment-admin-links-no-icon";
				$timer_class = "ajax-edit-time-left-no-icon";
			}
			if ($this->adminOptions['clear_after'] == 'true') {
				$clearfix = "clearfix";
			}
			$aec_content_arr = array();
			//For anonymous users
			if (!$this->is_comment_owner($postID)) {
				$aeccontent = "<a title='".__('Comment Editor',$this->localizationName)."' class='$edit_class' href='$edit_url' onclick='return jQuery.ajaxeditcomments.edit(this);' id='edit-$commentID'>";
				if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$aeccontent .= "<span class='aec-icons $edit_class'></span>";
				$aeccontent .= "<span class='aec_anon_text'>" .  __("Click to Edit",$this->localizationName) . "</span>";
				if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$aeccontent .= "<span class='aec-icons $edit_class'></span>";
				$aeccontent .= "</a>";
				array_push($aec_content_arr, $aeccontent);
				//check if deletion option is on
				if ($this->adminOptions['request_deletion_behavior'] == "request") {
					$aeccontent = "<a title='" . __('Request Deletion', $this->localizationName)."' class='$request_deletion_class' href='$request_deletion_url' onclick='return jQuery.ajaxeditcomments.request_deletion(this);' id='request-deletion-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$aeccontent .= "<span class='aec-icons $request_deletion_class'></span>";
					$aeccontent .= "<span class='aec_anon_text'>" .  __("Request Deletion",$this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$aeccontent .= "<span class='aec-icons $request_deletion_class'></span>";
					$aeccontent .= "</a>";
					array_push($aec_content_arr, $aeccontent);
				} elseif ($this->adminOptions['request_deletion_behavior'] == "delete") {
					$aeccontent = "<a title='" . __('Delete', $this->localizationName)."' class='$request_deletion_class' href='$request_delete_url' onclick='return jQuery.ajaxeditcomments.request_delete(this);' id='request-delete-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$aeccontent .= "<span class='aec-icons $request_deletion_class'></span>";
					$aeccontent .= "<span class='aec_anon_text'>" .  __("Delete",$this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$aeccontent .= "<span class='aec-icons $request_deletion_class'></span>";
					$aeccontent .= "</a>";
					array_push($aec_content_arr, $aeccontent);
				} 
				if ($this->adminOptions['icon_display'] == 'noicons') 
					$content .= sprintf("[%s]", implode(' | ', $aec_content_arr));
				else 
					$content .= implode('', $aec_content_arr);
				//Check to see if timer is on
				if ($this->adminOptions['show_timer'] == 'true') {
					//Check to see if user is logged in and admin can indefinitely edit
					if (!$this->can_indefinitely_edit($comment->user_id)) {
						$content .= " <span class='ajax-edit-time-left $timer_class' id='ajax-edit-time-left-$commentID'></span>";
					}
				}
				$content .= "<br style='clear: left;' />";
				return $content;
			}
			$options = $this->get_user_options();
			if ($options['comment_editing'] == "true" || (is_admin() && $options['admin_editing'] == "false")) { 
					//Admin Options
					//Edit link
					$edit = "<a title='".__('Comment Editor',$this->localizationName)."' href='$edit_url' onclick='return jQuery.ajaxeditcomments.edit(this);' id='edit-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$edit .= "<span class='aec-icons $edit_class'></span>";
					$edit .= "<span class='aec_link_text'>" .  __('Edit', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$edit .= "<span class='aec-icons $edit_class'></span>";
					$edit .= "</a>";
					
					//Restore Link
					$restore = "<a title='" . __("Restore", $this->localizationName) . "'  href='$restore_url' onclick='jQuery.ajaxeditcomments.restore_comment(this); return false;' id='restore-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$restore .= "<span class='aec-icons $approve_class'></span>";
					$restore .= "<span class='aec_link_text'>" . __('Restore', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$restore .= "<span class='aec-icons $approve_class'></span>";
					$restore .= "</a>";
					
					//Delete Permanently link
					$delete_perm = "<a title='" . __("Delete Permanently", $this->localizationName) . "'  href='$deleteperm_url' onclick='jQuery.ajaxeditcomments.deleteperm_comment(this); return false;' id='deleteperm-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$delete_perm .= "<span class='aec-icons $delete_class'></span>";
					$delete_perm .= "<span class='aec_link_text'>" . __('Delete Permanently', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$delete_perm .= "<span class='aec-icons $delete_class'></span>";
					$delete_perm .= "</a>";
					
					//Email link
					if (!empty($comment->comment_author_email)) {
						$email = "<a title='" . __("E-mail", $this->localizationName) . "' href='$email_url' onclick='return jQuery.ajaxeditcomments.email(this);' id='email-$commentID'>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
							$email .= "<span class='aec-icons $email_class'></span>";
						$email .= "<span class='aec_link_text'>" . __('E-mail', $this->localizationName) . "</span>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
							$email .= "<span class='aec-icons $email_class'></span>";
						$email .= "</a>";
					} else {
						$email = '';
					}
					
					//Move Comments Link
					$move = "<a title='" . __("Move Comments", $this->localizationName) . "' href='$move_comment_url' onclick='return jQuery.ajaxeditcomments.move(this);' id='move-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$move .= "<span class='aec-icons $move_class'></span>";
					$move .= "<span class='aec_link_text'>" . __('Move', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$move .= "<span class='aec-icons $move_class'></span>";
					$move .= "</a>";
					
					//Delink link
					if (!empty($comment->comment_author_url) && $comment->comment_author_url != "http://") {
						$delink_link = "<a title='" . __("De-link", $this->localizationName) . "'  href='$delink_url' onclick='jQuery.ajaxeditcomments.delink(this); return false;' id='delink-$commentID'>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
							$delink_link .= "<span class='aec-icons $delink_class'></span>";
						$delink_link .= "<span class='aec_link_text'>" . __('De-link', $this->localizationName) . "</span>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
							$delink_link .= "<span class='aec-icons $delink_class'></span>";
						$delink_link .= "</a>";
					 } else {
					 	$delink_link = '';
					 }
					
					//Approve link
					if ($comment->comment_approved == "0" || $comment->comment_approved == "spam") {
						$approve = "<a title='" . __("Approve", $this->localizationName) . "'  href='$approve_url' onclick='jQuery.ajaxeditcomments.approve(this); return false;' id='approve-$commentID'>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
							$approve .= "<span class='aec-icons $approve_class'></span>";
						$approve .= "<span class='aec_link_text'>" . __('Approve', $this->localizationName) . "</span>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
							$approve .= "<span class='aec-icons $approve_class'></span>";
						$approve .= "</a>";
					} else {
						$approve = '';
					}
					
					//Moderate link
					if ($comment->comment_approved != "0") {
						$moderate = "<a title='" . __("Moderate", $this->localizationName) . "'  href='$moderate_url' onclick='jQuery.ajaxeditcomments.moderate(this); return false;' id='moderate-$commentID'>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
							$moderate .= "<span class='aec-icons $moderate_class'></span>";
						$moderate .= "<span class='aec_link_text'>" . __('Moderate', $this->localizationName) . "</span>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
							$moderate .= "<span class='aec-icons $moderate_class'></span>";
						$moderate .= "</a>";
					} else {
						$moderate = '';
					}
		
					//Spam link
					if ($comment->comment_approved != "spam") {
						$spam = "<a title='" . __("Spam", $this->localizationName) . "'  href='$spam_url' onclick='jQuery.ajaxeditcomments.spam(this); return false;' id='spam-$commentID'>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
							$spam .= "<span class='aec-icons $spam_class'></span>";
						$spam .= "<span class='aec_link_text'>" . __('Spam', $this->localizationName) . "</span>";
						if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
							$spam .= "<span class='aec-icons $spam_class'></span>";
						$spam .= "</a>";
					} else {
						$spam = '';
					}

					//Blacklist link
					$blacklist = "<a title='" . __("Blacklist", $this->localizationName) . "'  title='".__('Blacklist Comment', $this->localizationName)."'  href='$blacklist_url' onclick='jQuery.ajaxeditcomments.blacklist_comment(this); return false;' id='blacklist-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$blacklist .= "<span class='aec-icons $blacklist_class'></span>";
					$blacklist .= "<span class='aec_link_text'>" . __('Blacklist', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$blacklist .= "<span class='aec-icons $blacklist_class'></span>";
					$blacklist .= "</a>";
					
					//Delete link
					$delete = "<a title='" . __("Trash", $this->localizationName) . "'  href='$delete_url' onclick='jQuery.ajaxeditcomments.delete_comment(this); return false;' id='delete-$commentID'>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'false')
						$delete .= "<span class='aec-icons $delete_class'></span>";
					$delete .= "<span class='aec_link_text'>" . __('Trash', $this->localizationName) . "</span>";
					if ($this->adminOptions['icon_display'] != 'noicons' && $this->adminOptions['use_rtl'] == 'true')
						$delete .= "<span class='aec-icons $delete_class'></span>";
					$delete .= "</a>";
					$delete .= "";
					
					//For the trash view
					if ($comment->comment_approved == 'trash') {
						$aec_content_arr = array($edit, $restore, $delete_perm);
						if ($this->adminOptions['icon_display'] == 'noicons') 
							$content .= sprintf("[%s]", implode(' | ', $aec_content_arr));
						else 
							$content .= implode('', $aec_content_arr);
						return $content;
					}
					if ($this->adminOptions['icon_display'] == "dropdown") {
						//Enable dropdown menu
						$content .= $edit;
						$content .= "<span class='aec-dropdownarrow' id='aec-dropdownarrow-$commentID'>";
						$content .= "<a class='aec-dropdownlink' href='cid=$commentID' onclick='jQuery.ajaxeditcomments.dropdown(this); return false;' id='aec-dropdownlink-$commentID'>";
						$content .= "<span class='aec-icons'></span>";
						$content .= "<span id='aec-dropdownlink-text-$commentID'>" . __('More Options', $this->localizationName) . "</span>";
						$content .= "</a></span>";
						
						//Fill dropdown menu
						$content .= "<span class='aec-dropdown' id='aec-dropdown-$commentID'>"; //start dropdown menu container
						$dropdown = $this->adminOptions['drop_down'];
						
						//Create the array columns
						$columns = array('column0'=>array(),'column1'=>array(), 'column2'=> array());
						foreach ($dropdown as $items => $item) {
							switch ($item['column']) {
								case "0":
									$columns['column0'][sizeof($columns['column0'])] = $item;
									break;
								case "1":
									$columns['column1'][sizeof($columns['column1'])] = $item;
									break;
								case "2":
									$columns['column2'][sizeof($columns['column2'])] = $item;
									break;
							}	
						}
						//Remove empty columns						
						if (sizeof($columns['column0']) == 0) 
							unset($columns['column0']);
						if (sizeof($columns['column1']) == 0) 
							unset($columns['column1']);
						if (sizeof($columns['column2']) == 0) 
							unset($columns['column2']);
						
						//Build the columns for the dropdown
						$cols = array();
						foreach ($columns as $column) {
							usort($column, array(&$this,'build_admin_links_sort'));
							//Build the items
							$items = '';
							foreach ($column as $info) {
								if ($info['enabled'] == '0') 
									continue;
								
								//Build column links
								switch($info['id']) {
									case 'dropdownapprove':
										if ($comment->comment_approved == "0" || $comment->comment_approved == "spam")
											$items .= $approve;
										break;
									case 'dropdownmoderate':
										if ($comment->comment_approved != "0") 
											$items .= $moderate;
										break;
									case 'dropdownspam':
										if ($comment->comment_approved != "spam")
											$items .= $spam;
										break;
									case 'dropdowndelink':
										if (!isset($delink))  //don't delink a comment if it has no link
											$items .= $delink_link;
										break;
									case 'dropdowndelete':
										$items .= $delete;
										break;
									case 'dropdownblacklist':
										$items .= $blacklist;
										break;
									case 'dropdownemail':
										$items .= $email;
										break;
									case 'dropdownmove':
										$items .= $move;
										break;
								} //end switch
							} //end foreach
							$cols[sizeof($cols)] = $items;
						} //end foreach
						
						
						//Output the column containers for the dropdown
						for ($i = 0; $i < sizeof($cols); $i++) {
							$content .= "<span style='display:block;float:left'>";
							$content .= $cols[$i];
							$content .= "</span>";
						}
						
						$content .= "</span>"; //end dropdown menu container
					} elseif($this->adminOptions['icon_display'] == "classic" || $this->adminOptions['icon_display'] == "iconsonly" || $this->adminOptions['icon_display'] == 'noicons'){
						//Clasic view
						$classic = $this->adminOptions['classic'];
						$columns = array();
						foreach ($classic as $items => $item) {
							if ($item['enabled'] == '0') { continue; }
							$columns[sizeof($columns)] = $item;
						}
						//Create the array columns
						usort($columns, array(&$this,'build_admin_links_sort_classic'));
						//Build the columns for the dropdown
						foreach ($columns as $column) {
							//Build column links
							switch($column['id']) {
								case 'edit':
									array_push($aec_content_arr,$edit);
									break;
								case 'approve':
									if ($comment->comment_approved == "0" || $comment->comment_approved == "spam")
										array_push($aec_content_arr,$approve);
									break;
								case 'moderate':
									if ($comment->comment_approved != "0") 
										array_push($aec_content_arr,$moderate);
									break;
								case 'spam':
									if ($comment->comment_approved != "spam")
										array_push($aec_content_arr,$spam);
									break;
								case 'delink':
									if (!isset($delink))  //don't delink a comment if it has no link
										array_push($aec_content_arr,$delink_link);
									break;
								case 'delete':
									array_push($aec_content_arr,$delete);
									break;
								case 'blacklist':
									array_push($aec_content_arr,$blacklist);
									break;
								case 'email':
									array_push($aec_content_arr,$email);
									break;
								case 'move':
									array_push($aec_content_arr,$move);
									break;
							} //end switch
							
						} //end foreach
						if ($this->adminOptions['icon_display'] == 'noicons') 
							$content .= sprintf("[%s]", implode(' | ', $aec_content_arr));
						else 
							$content .= implode('', $aec_content_arr);
					} //endif
					$content .= "<br style='clear:left' />";
					return $content;
			}
			return $content;
		} //end build admin links
		//Sorts arrays for the drop-down feature
		function build_admin_links_sort($a, $b) {
			return strnatcmp($a['position'], $b['position']); 
		}
		//Sorts arrays for the drop-down feature
		function build_admin_links_sort_classic($a, $b) {
			return strnatcmp($a['column'], $b['column']); 
		}
		//Builds an undo message
		function build_undo_url($action,$commentID,$postID, $message) {
				$undo_url = clean_url(wp_nonce_url(get_bloginfo('url') . "/?aec_page=ajax-processor.php&action=$action&pid=$postID&cid=$commentID", $action . "_" . $commentID));
				if ($this->adminOptions['use_wpload'] == 'true')
					$undo_url = clean_url(wp_nonce_url(plugins_url('wp-ajax-edit-comments') . "/php/ajax-processor.php?action=$action&pid=$postID&cid=$commentID", $action . "_" . $commentID));
				$undo = "<em>$message<span class='aec-undo-span undo$commentID'> - <a href='$undo_url' class='aec-undo-link'>" . __('Undo', $this->localizationName) . "</a></em></span>";
				return $undo;
		}
		/*
		can_edit - Determines if a user can edit a particular comment on a particular post
		Parameters - commentID, postID
		Returns - Enumeration (0=unsuccessful,1=successful,or string error code)
		*/
		function can_edit($commentID = 0, $postID = 0) {
			global $wpdb;
			
			//Check if admin/editor/post author
			if ($this->is_comment_owner($postID)) {
				return 1;
			}
			
			//Get the current comment, if necessary
			$comment = $this->get_edit_comment($commentID); 
			
			//Check to see if the user is logged in and can indefinitely edit
			if ($comment['user_id'] != 0) {
				if ($this->adminOptions['allow_registeredediting'] == 'false')
					return 'no_user_editing';
			} else {
				//Check to see if admin allows comment editing for anonymous users
				if ($this->adminOptions['allow_editing'] == "false") 
					return 'no_user_editing';
			}
			
			if (!$comment) { return 'get_comment_failed'; }
			//Check to see if the comment is spam
			if ($comment['comment_approved'] === 'spam') { 
				return 'comment_spam';
			}
			
			//Check to see if the user is logged in and can indefinitely edit
			if ($this->can_indefinitely_edit($comment['user_id'])) {
				return 1;
			}
			
			
			//Now we check to see if there is any time remaining for comments
			$timestamp = $comment['time'];
			$time = current_time('timestamp',1)-$timestamp;
			$minutesPassed = round(((($time%604800)%86400)%3600)/60); 

			//Get the time the admin has set for minutes
			$minutes = $this->adminOptions['minutes'];
			if (!is_numeric($minutes)) {
				$minutes = $this->minutes; //failsafe
			}
			if ($minutes < 1) {
				$minutes = $this->minutes;
			}
			if (($minutesPassed - $minutes) > 0) {
				return 'comment_time_elapsed';
			}
			
			//Now check if options allow editing after an additional comment has been made
			if ($this->adminOptions['allow_editing_after_comment'] == "false") {
				//Admin doesn't want users to edit - so now check if any other comments have been left
				$query = "SELECT comment_ID from $wpdb->comments where comment_post_ID = $postID and comment_type <> 'pingback' and comment_type <> 'trackback' order by comment_ID DESC limit 1";
				$newComment = $wpdb->get_row($query, ARRAY_A); 
				if (!$newComment) { return 'new_comment_posted'; }
				//Check to see if there is a higher comment ID
				if ($commentID != $newComment['comment_ID']) { return 'new_comment_posted'; }
			}
			//Get post security key
			$postContent = $wpdb->get_row("SELECT meta_value FROM $wpdb->postmeta WHERE post_id = " . $comment['comment_post_ID'] . " and meta_key = '_" . $comment['comment_ID'] . "'", ARRAY_A);//$wpdb->get_row("SELECT post_content from $wpdb->posts WHERE post_type = 'ajax_edit_comments' and guid = $commentID order by ID desc limit 1", ARRAY_A);
			if (!$postContent) { return 'comment_edit_denied'; }
			
			$hash = md5($comment['comment_author_IP'] . $comment['comment_date_gmt']);
			
			//Now check to see if there's a valid cookie
			if ($GLOBALS[$this->cookieName . $commentID . $hash]=='' ){ //For compatability with CFORMS
				if (isset($_COOKIE[$this->cookieName . $commentID . $hash])) {
					if ($_COOKIE[$this->cookieName . $commentID . $hash] != $postContent['meta_value']) { return 'comment_edit_denied'; }
				} else {
					return 'comment_edit_denied';
				}
			} else {
				if ($GLOBALS[$this->cookieName . $commentID . $hash] != $postContent['meta_value']) { return 'comment_edit_denied'; }
			}
			return 1;  //Yay, user can edit
		} //End function can_edit
		/*
		can_edit_quickckech - Quick check without DB access before can_edit() --ag
		Parameters - comment
		Returns - Enumeration (0=unsuccessful,1=successful,or string error code)
		*/
		function can_edit_quickcheck($comment) {
			//Check if admin/editor/post author
			if ($this->is_comment_owner($comment->comment_post_ID)) {
				return 1;
			}
			//Check to see if the user is logged in and can indefinitely edit
			if ($this->can_indefinitely_edit($comment->user_id)) {
			return 1;
			}
			

			//Now we check to see if there is any time remaining for comments
			$timestamp = strtotime($comment->comment_date);
			$time = current_time('timestamp',get_option('gmt_offset'))-$timestamp;
						$minutesPassed = round(((($time%604800)%86400)%3600)/60); 

			//Get the time the admin has set for minutes
			$minutes = $this->adminOptions['minutes'];
			if (!is_numeric($minutes)) {
				$minutes = $this->minutes; //failsafe
			}
			if ($minutes < 1) {
				$minutes = $this->minutes;
			}
			if (($minutesPassed - $minutes) > 0) {
				return 'comment_time_elapsed';
			} else {
				return 1;  //Yay, user can edit
			}

		} //End function can_edit_quickcheck
		/* can_edit_name - Checks to see if a user can edit a name
		Parameters - $commentID, $postID
		Returns true if one can, false if not */
		function can_edit_name($commentID, $postID) {
			if ($this->is_comment_owner($postID)) { return true; }
			$comment = get_comment($commentID, ARRAY_A);
			if ($this->is_logged_in($comment['user_id'])) { //logged in
				if ($this->adminOptions['registered_users_name_edit'] == "true") { return true;}
			} else { //not logged in 
				if ($this->adminOptions['allow_name_editing'] == "true") { return true;}
			}
			return false;
		}
		/* can_edit_email - Checks to see if a user can edit an e-mail address
		Parameters - $commentID, $postID
		Returns true if one can, false if not */
		function can_edit_email($commentID, $postID) {
			$comment = get_comment($commentID, ARRAY_A);
			//Return false if comment is pingback or trackback
			if ($comment['comment_type'] == "pingback" || $comment['comment_type'] == 'trackback') { return false; }
			if ($this->is_comment_owner($postID)) { return true; }	
			
			if ($this->is_logged_in($comment['user_id'])) { //logged in
				if ($this->adminOptions['registered_users_email_edit'] == "true") { return true;}
			} else { //not logged in 
				if ($this->adminOptions['allow_email_editing'] == "true") { return true;}
			}
			return false;
		}
		/* can_edit_url - Checks to see if a user can edit a url
		Parameters - $commentID, $postID
		Returns true if one can, false if not */
		function can_edit_url($commentID, $postID) {
			if ($this->is_comment_owner($postID)) { return true; }
			$comment = get_comment($commentID, ARRAY_A);
			if ($this->is_logged_in($comment['user_id'])) { //logged in
				if ($this->adminOptions['registered_users_url_edit'] == "true") { return true;}
			} else { //not logged in 
				if ($this->adminOptions['allow_url_editing'] == "true") { return true;}
			}
			return false;
		}
		/* can_edit_options - Checks to see if a non-admin user can edit various options 
		Parameters - $commentID, $postID
		Returns true if one can, false if not */
		function can_edit_options($commentID, $postID) {
			if ($this->is_comment_owner($postID)) { return true; }
			$comment = get_comment($commentID, ARRAY_A);
			if ($this->is_logged_in($comment['user_id'])) { //logged in
				if ($this->adminOptions['registered_users_url_edit'] == "true" || $this->adminOptions['registered_users_email_edit'] == "true" || $this->adminOptions['registered_users_name_edit'] == "true" ) { return true;}
			} else { //not logged in 
				if ($this->adminOptions['allow_url_editing'] == "true" || $this->adminOptions['allow_email_editing'] == "true" || $this->adminOptions['allow_name_editing'] == "true") { return true;}
			}
			return false;
		}
		/* can_indefinitely_edit
		Parameters - $userID
		Returns - true if can, false if not */
		function can_indefinitely_edit($userID = 0) {
			if ($this->is_logged_in($userID)) {
				//User is logged in and this is the user's comment - Does admin allow indefinite editing?
				if ($this->adminOptions['registered_users_edit'] == "true") {
					return true; //Logged in user can indefinitely edit
				}
			}
			return false;
		}
		/* can_scroll 
		Checks to see if an admin can scroll to the comment or not 
		Returns - true if can, false if not*/
		function can_scroll($postID) {
			if ($this->is_comment_owner($postID)) {
				if ($this->adminOptions['javascript_scrolling'] == "true") {
					return "true";
				}
			}
			return "false";
		}
		/* check_spam - Checks an edited comment for spam 
		Parameters - $commentID, $postID
		Returns - True if spam, false if not */
		function check_spam($commentID = 0, $postID = 0) {
			$options = $this->adminOptions;
			//Check to see if spam protection is enabled
			if ($options['spam_protection'] == "none") { return false;} 
			//Return if user is post author or can edit posts
			if ($this->is_comment_owner($postID)) { return false; }
			
			if (function_exists("akismet_check_db_comment") && $options['spam_protection'] == 'akismet') { //Akismet
				//Check to see if there is a valid API key
				if (akismet_verify_key(get_option('wordpress_api_key')) != "failed") { //Akismet
					$response = akismet_check_db_comment($commentID);
					if ($response == "true") { //You have spam
						wp_set_comment_status($commentID, 'spam');
						return true;
					}
				}
			} elseif ($options['spam_protection'] == "defensio" && function_exists('defensio_post') ) { //Defensio
				global $defensio_conf, $wpdb;
				$comment = get_comment($commentID, ARRAY_A);
				if (!$comment) { return true; }
				$comment['owner-url'] = $defensio_conf['blog'];
				$comment['user-ip'] = $comment['comment_author_IP'];
				$comment['article-date'] = strftime("%Y/%m/%d", strtotime($wpdb->get_var("SELECT post_date FROM $wpdb->posts WHERE ID=" . $comment['comment_post_ID'])));
				$comment['comment-author'] = $comment['comment_author'];
				$comment['comment-author-email'] = $comment['comment_author_email'];
				$comment['comment-author-url'] = $comment['comment_author_url'];
				$comment['comment-content'] = defensio_unescape_string($comment['comment_content']);
				if (!isset($comment['comment_type']) or empty($comment['comment_type'])) {
					$comment['comment-type'] = 'comment';
				} else {
					$comment['comment-type'] = $comment['comment_type'];
				}
				if (defensio_reapply_wp_comment_preferences($comment) === "spam") {
					return true;
				}
				$results = defensio_post('audit-comment',$comment);
				$ar = Spyc :: YAMLLoad($results);
				if (isset($ar['defensio-result'])) {
					if ($ar['defensio-result']['spam']) {
						wp_set_comment_status($commentID, 'spam');
						return true;
					}
				}
			}
			return false;			
		} //end function check_spam
		/* - comment_edited - Run after a comment has successfully been edited 
		Parameters - $commentID, $postID*/
		function comment_edited($commentID = 0, $postID = 0) {
			//Clear the comment cache
			if (function_exists('clean_comment_cache')) { clean_comment_cache($commentID); }
			
			//For WP Cache and WP Super Cache
			if (function_exists('wp_cache_post_change')) {
				@wp_cache_post_change($postID);
			}
			//Get out if user is admin or post owner
			if ($this->is_comment_owner($postID)) { return; }
			
			//Increment the number of edited comments
			$this->increment_edit_count();
		} //end function comment_edited
		/* comment_posted - This function is run whenever a comment is posted - 
		Adds a cookie and security key for future editing
		Parameters - $commentID (the comment's ID)
		*/
		function comment_posted($commentID=0) {
			global $wpdb;
			//Get comment
			$comment = get_comment($commentID, ARRAY_A);
			//Some sanity checks
			if (!$comment) { return;}
			
			//if ($comment['comment_approved'] == "1") { return; }	
			if ($comment['comment_approved'] == "spam") { return; }	
			//If admin, exit since we don't want to add anything
			if ($this->is_comment_owner($comment['comment_post_ID'])) {
				return $commentID;
			}
			//Check to see if the user is logged in and can indefinitely edit
			if ($comment['user_id'] != 0) {
				if ($this->adminOptions['allow_registeredediting'] == 'false')
					return 'no_user_editing';
			} else {
				//Check to see if admin allows comment editing for anonymous users
				if ($this->adminOptions['allow_editing'] == "false") 
					return 'no_user_editing';
			}
			//Don't save data if user can indefinitely edit
			if ($this->can_indefinitely_edit($comment['user_id'])) { return; }
			
			
			//Get hash and random security key
			$hash = md5($comment['comment_author_IP'] . $comment['comment_date_gmt']);
			$rand = 'wpAjax' . $hash . md5($this->random()) . md5($this->random());
			
			//Get the minutes allowed to edit
			$minutes = $this->adminOptions['minutes'];
			if (!is_numeric($minutes)) {
				$minutes = $this->minutes;
			}
			if ($minutes < 1) {
				$minutes = $this->minutes;
			}		
			//Insert the random key into the database
			$query = "INSERT INTO " . $wpdb->postmeta .
				"(post_id, meta_key, meta_value) " .
				"VALUES (" . $comment['comment_post_ID'] . ",'_" . $comment['comment_ID'] . "','" . $rand . "')";
			@$wpdb->query($query);
			
			//Set the cookie
			$cookieName = $this->cookieName . $commentID . $hash;
			$value = $rand;
			$expire = time()+60*$minutes;
			if (!isset($_COOKIE[$cookieName])) {
				setcookie($cookieName, $value, $expire, COOKIEPATH,COOKIE_DOMAIN);
				//setcookie($cookieName, $value, $expire, SITECOOKIEPATH,COOKIE_DOMAIN);
				$GLOBALS[$cookieName] = $value; //For compatability with CFORMS
			}
			
			//Read in security key count, delete keys if over 100
			$securityCount = get_option('ajax-edit-comments_security_key_count');
			if (!securityCount) {
				$securityCount = 1;  update_option('ajax-edit-comments_security_key_count', $securityCount);
			} else {
				$securityCount = (int)$securityCount;
			}
			//Delete keys if over a 100
			if ($securityCount >= 100) {
				$metakey = "_" . $comment['comment_ID'];
				@$wpdb->query("delete from $wpdb->postmeta where left(meta_value, 6) = 'wpAjax' and meta_key <> '$metakey'");
				$securityCount = 0;
			}
			$securityCount += 1;
			update_option('ajax-edit-comments_security_key_count', $securityCount);
			return $commentID;
		}//End function comment_posted
		/* delete_comment */
		function delete_comment($commentID = 0, $postID = 0) {
			if ($this->is_comment_owner($postID)) {
				$status = wp_delete_comment($commentID)? "1" : 'delete_failed';
				return $status;
			} else {
				return 'delete_failed_permission';
			}
		}
		/*Delinks a comment */
		function delink_comment($commentID = 0, $postID = 0, $comment = '') {
			if ($this->is_comment_owner($postID)) {
				wp_update_comment($comment);
				return "1";
			} else {
				return 'delink_failed_permission';
			}
		}
		/* disable_selfpings - Disables WordPress sites from pinging themselves
		Parameters - $links 
		Credits - http://blogwaffe.com/ */
		function disable_selfpings(&$links) {
			$home = get_option( 'home' );
			foreach ( $links as $l => $link ) {
				if ( 0 === strpos( $link, $home ) )
					unset($links[$l]);
			}
		}
		//When a comment is edited, an e-mail notification is sent out
		//Parameters - $commentID (a comment ID) and $postID (a post ID)
		//Returns false if e-mail failed
		function edit_notification($commentID = 0, $postID = 0) {
			global $wpdb;
			$options = $this->adminOptions;
			//Check admin options and also if user editing is post author
			if ($options['email_edits'] == "false") { return false; }
			//Get the comment and post
			$comment = get_comment($commentID, ARRAY_A);
			if (empty($comment)) { return false; }
			$query = "SELECT * FROM $wpdb->posts WHERE ID=$postID";
			$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID=$postID", ARRAY_A);
			
			if (!$post) { return false; }
			if ($this->is_comment_owner($postID)) {  return false; }
			//Make sure the comment is approved and not a trackback/pingback
			if ( $comment['comment_approved'] == '1' && ($comment['comment_type'] != 'pingback' || $comment['comment_type'] != 'trackback')) { 
			//Put together the e-mail message
			$message  = sprintf(__("A comment has been edited on post %s", $this->localizationName) . ": \n%s\n\n", stripslashes($post['post_title']), get_permalink($comment['comment_post_ID']));
			$message .= sprintf(__("Author: %s\n", $this->localizationName), $comment['comment_author']);
			$message .= sprintf(__("Author URL: %s\n", $this->localizationName), stripslashes($comment['comment_author_url']));
			$message .= sprintf(__("Author E-mail: %s\n", $this->localizationName), stripslashes($comment['comment_author_email']));
			$message .= __("Comment:\n", $this->localizationName) . stripslashes($comment['comment_content']) . "\n\n";
			$message .= __("See all comments on this post here:\n", $this->localizationName);
			$message .= get_permalink($comment['comment_post_ID']) . "#comments\n\n";
			$subject = sprintf(__('New Edited Comment On: %s', $this->localizationName), stripslashes($post['post_title']));
			$subject = '[' . get_bloginfo('name') . '] ' . $subject;
			$email = get_bloginfo('admin_email');
			$site_name = str_replace('"', "'", get_bloginfo('name'));
			$charset = get_settings('blog_charset');
			$headers  = "From: \"{$site_name}\" <{$email}>\n";
			$headers .= "MIME-Version: 1.0\n";
			$headers .= "Content-Type: text/plain; charset=\"{$charset}\"\n";
			//Send the e-mail
			return wp_mail($email, $subject, $message, $headers);
			}
			return false;
		} //End function edit_notification
		/* encode - Encodes comment content to various charsets 
		Parameters - $content - The comment content 
		Returns the encoded content */ 
		function encode($content) {
			if ($this->adminOptions['use_mb_convert'] == "false" || !function_exists("mb_convert_encoding")) { return $content; }
			return mb_convert_encoding($content, ''.get_option('blog_charset').'', mb_detect_encoding($content, "UTF-8, ISO-8859-1, ISO-8859-15", true));
		}
		/* filter_comments_number - Updates the comment number with no trackbacks
		Parameters - $count - The current comment count for a post
		Returns the updated comment count */
		function filter_comments_number($count) {
			global $id;
			if (empty($id)) { return $count; }
			$comments = get_approved_comments((int)$id);
			$comments = array_filter($comments, array(&$this, 'filter_strip_trackbacks'));
			return sizeof($comments);
		}
		/* filter_strip_trackbacks
		Parameters - $comment - The comment to extract the trackback
		Returns true if no trackback is present, else false*/
		function filter_strip_trackbacks($comment) {
			if ($comment->comment_type == 'trackback' || $comment->comment_type == 'pingback')
				return false;
			return true;
		}
		/* filter_trackbacks - Strips trackbacks from the comments loop
		Parameters - $comms - The passed comments
		Returns the comments array without trackbacks
		*/
		function filter_trackbacks($comms) {
			global $comments;
			$comments = array_filter($comms,array(&$this, 'filter_strip_trackbacks'));
			return $comments;
		}
		/* get_comment - Returns a comment ready for editing
		parameters - $commentID
		returns - a response object (WP_Ajax_Response) */
		function get_comment($commentID = 0) {
			$comment = get_comment($commentID);
			$response = new WP_Ajax_Response();
			if (!$comment) { 
				$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => $this->get_error('get_comment_failed')
				));
				$response->send(); return;
			}
			//Check to see if the comment is spam if the user isn't admin or comment owner
			if (!$this->is_comment_owner($comment->comment_post_ID)) {
				if ($comment->comment_approved === 'spam') { 
					$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => $this->get_error('comment_spam')
					));
					$response->send(); return;
				}
			}
			
			//Check to see if user can edit and return any appropriate error messages
			$message = $this->can_edit($commentID, $comment->comment_post_ID);
			if (is_string($message)) {
				$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => $this->get_error($message)
				));
				$response->send(); return;
			}
			//Okay, user can edit - Let's prepare the comment for editing
			$comment->comment_content = format_to_edit( $comment->comment_content ,1);
			$comment->comment_content = apply_filters( 'comment_edit_pre', $comment->comment_content);
			$comment->comment_author = format_to_edit( $comment->comment_author );
			$comment->comment_author_email = format_to_edit( $comment->comment_author_email );
			$comment->comment_author_url = clean_url($comment->comment_author_url);
			$comment->comment_author_url = format_to_edit( $comment->comment_author_url );
			//Prepare the response
			$response->add( array(
					'what' => 'comment_content',
					'id' => $commentID,
					'data' => $comment->comment_content
				));
			$response->add( array(
					'what' => 'comment_author',
					'id' => $commentID,
					'data' => $comment->comment_author
				));
			$response->add( array(
					'what' => 'comment_author_email',
					'id' => $commentID,
					'data' => $comment->comment_author_email
				));
			$response->add( array(
					'what' => 'comment_author_url',
					'id' => $commentID,
					'data' => $comment->comment_author_url
				));
			if ($this->adminOptions['show_gravatar'] == "true") {
				$gravatar = get_avatar($comment, '40');
				if (!empty($gravatar)) {
					$response->add( array(
							'what' => 'gravatar',
							'id' => $commentID,
							'data' => $gravatar
						));
					}
			}
			$response = apply_filters('wp_ajax_comments_get_comment', $response, $comment);
			$response->send();
		}//End function get_comment
		/* get_comment_id - Returns an ID based on an incoming string */
		function get_comment_id($string) {
			preg_match('/([0-9]+)$/i', $string, $matches);
			if (is_numeric($matches[1])) {
				return $matches[1];
			} 
			return 0;
		} 
		/*
		get_can_comment - Get comment values, if necessary
		Parameters - commentID
		Returns - Array of values for comment if successfull
		*/
		function get_edit_comment($commentID) {
			global $comment, $wpdb;

			if ($comment->comment_ID == $commentID) {
				$c = get_object_vars($comment);
				$c['time'] = mysql2date('U', $c['comment_date']);
				return $c;
			}

			$query = "SELECT UNIX_TIMESTAMP(comment_date) time, comment_author_email, comment_author_IP, comment_date_gmt, comment_post_ID, comment_approved, comment_ID, user_id  FROM $wpdb->comments where comment_ID = $commentID";
			return($wpdb->get_row($query, ARRAY_A));
		}
		/* get_error - Returns an error message based on the passed code
		Parameters - $code (the error code as a string)
		Returns an error message */
		function get_error($code = '') {
			//Try to initialize errors if the object doesn't exist
			if (!is_object($this->errors)) {
				$this->initialize_errors();
				if (!is_object($this->errors))
					return __("Unknown error.", $this->localizationName);
			}
			//Get the error message and return it 
			$errorMessage = $this->errors->get_error_message($code);
			if ($errorMessage == null) {
				return __("Unknown error.", $this->localizationName);
			}
			return __($errorMessage, $this->localizationName); 
		}
		/* get_time_left - Returns time remaining in seconds
		parameters - $commentID 
		Returns 1 if no time is necessary.  -1 if time is unavailable.  Time if available.
		*/
		function get_time_left($commentID = 0) {
			global $wpdb;
			$adminMinutes = (int)$this->adminOptions['minutes'];
			$query = "SELECT ($adminMinutes * 60 - (UNIX_TIMESTAMP('" . current_time('mysql') . "') - UNIX_TIMESTAMP(comment_date))) time, comment_author_email, user_id FROM $wpdb->comments where comment_ID = $commentID";
			
			//Get the Timestamp
			$comment = $wpdb->get_row($query, ARRAY_A);
			if (!$comment) { 
				$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => "-1"
				));
				$response->send();
			}
			if ($this->can_indefinitely_edit($comment['user_id'])) {	
				$response->add( array(
					'what' => 'success',
					'id' => $commentID,
					'data' => "1"
				));			
			}
			//Get the time elapsed since making the comment
			if ((int)$comment['time'] <= 0) { return "-1"; }
			$timeleft = (int)$comment['time'];
			$minutes = floor($timeleft/60);
			$seconds = $timeleft - ($minutes*60);
			$response = new WP_Ajax_Response();
			$response->add( array(
				'what' => 'minutes',
				'id' => $commentID,
				'data' => $minutes
			));
			$response->add( array(
				'what' => 'seconds',
				'id' => $commentID,
				'data' => $seconds
			));
			$response->send();
		}//end function get_time_left
		/* get_posts - Returns five posts with an offset
		parameters - $offset 
		Returns five posts with an offset
		*/
		function get_posts($offset = 0) {
			global $wpdb;
			$response = new WP_Ajax_Response();
			$results = $wpdb->get_results("select ID, post_title from $wpdb->posts where post_type = 'post' and post_status = 'publish' order by ID desc limit $offset,5", ARRAY_A);
			foreach ($results as $r) {
				$response->add(array(
					'what' => 'title',
					'id' => $r['ID'],
					'data' => $r['post_title']
				));
			}
			return $response;
		}
		/* get_posts_by_title - Returns five posts with an offset
		parameters - $title 
		Returns five posts by title
		*/
		function get_posts_by_title($title) {
			global $wpdb;
			$response = new WP_Ajax_Response();
			$results = $wpdb->get_results("select ID, post_title from $wpdb->posts where post_type = 'post' and post_status = 'publish' and post_title like '%$title%' limit 6", ARRAY_A);
			foreach ($results as $r) {
				$response->add(array(
					'what' => 'title',
					'id' => $r['ID'],
					'data' => $r['post_title']
				));
			}
			return $response;
		}
		/* get_posts_by_id - Returns five posts with an offset
		parameters - $id 
		Returns five posts by id
		*/
		function get_posts_by_id($id) {
			global $wpdb;
			$response = new WP_Ajax_Response();
			$results = $wpdb->get_row("select * from $wpdb->posts where post_type = 'post' and post_status = 'publish' and ID = $id", ARRAY_A);
			if ($results) {
				$response->add(array(
					'what' => 'title',
					'id' => $results['ID'],
					'data' => $results['post_title']
				));
			}
			return $response;
		}
		//Get a user's role
		function get_user_role() {
			global $current_user;
		
			$user_roles = $current_user->roles;
			$user_role = array_shift($user_roles);
		
			return $user_role;
		}
		/* increment_edit_count - Increments the number of edits */
		function increment_edit_count() {
			$numEdits = intval($this->adminOptions['number_edits']);
			$numEdits = number_format(intval($this->adminOptions['number_edits']));
			$numEdits += 1;
			
			$this->adminOptions['number_edits'] = $numEdits;
			$this->save_admin_options();
		}
		/* Initializes all the error messages */
		function initialize_errors() {
			$this->errors = new WP_Error();
			$this->errors->add('new_comment_posted', __('You cannot edit a comment after other comments have been posted.', $this->localizationName));
			$this->errors->add('comment_time_elapsed', __('The time to edit your comment has elapsed.',$this->localizationName));
			$this->errors->add('comment_edit_denied',__('You do not have permission to edit this comment.',$this->localizationName) );
			$this->errors->add('comment_marked_spam',$this->adminOptions['spam_text']);
			$this->errors->add('comment_spam',__('This comment cannot be edited because it is marked as spam.',$this->localizationName) );
			$this->errors->add('get_comment_failed',__('Comment loading failed.',$this->localizationName) );
			$this->errors->add('no_user_editing',__('Comment editing has been disabled.',$this->localizationName) );
			$this->errors->add('comment_spam_failed', __('Could not mark as spam.',$this->localizationName));
			$this->errors->add('comment_spam_failed_permission', __('You do not have permission to mark this comment as Spam.',$this->localizationName));
			$this->errors->add('delete_failed',__('Could not delete comment.',$this->localizationName) );
			$this->errors->add('delete_failed_permission',__('You do not have permission to delete this comment.',$this->localizationName) );
			$this->errors->add('approve_failed_permission', __('You do not have permission to approve this comment.',$this->localizationName));
			$this->errors->add('approve_failed', __('Could not approve comment.',$this->localizationName));
			$this->errors->add('moderate_failed', __('Could not mark this comment for moderation.',$this->localizationName));
			$this->errors->add('moderate_failed_permission', __('You do not have permission to mark this comment for moderation.',$this->localizationName));
			$this->errors->add('invalid_email', __('Please enter a valid email address.',$this->localizationName));
			$this->errors->add('required_fields', __('Please fill in the required fields (Name, E-mail)',$this->localizationName));
			$this->errors->add('content_empty',__('You cannot have an empty comment.',$this->localizationName) );
			$this->errors->add('delink_failed_permission',__('You do not have permission to delink this comment.',$this->localizationName) );
			$this->errors->add('comment_marked_moderated',__('Your comment was marked for moderation',$this->localizationName) );
			$this->errors->add('comment_moderated',__('This comment cannot be edited because it is marked for moderation.',$this->localizationName) );
			$this->errors->add('request_deletion_failed',__('Request failed.',$this->localizationName) );
			$this->errors->add('blacklist_empty',__('You have not selected anything to blacklist.',$this->localizationName) );
			$this->errors->add('upgrade_check_failed',__('Upgrade check failed.',$this->localizationName) );
			$this->errors->add('upgrade_check_none',__('You are using the latest version.',$this->localizationName) );
		} //end function initialize_errors
		/* init - Run upon WordPress initialization */
		function init() {
			//If registered users can only comment and user is not logged in, skip loading the plugin.
			include_once(ABSPATH . 'wp-includes/pluggable.php');
			if (get_option('comment_registration') == '1'){
				if (!is_user_logged_in()) {
					return;
				}
			}
				
			do_action('aec-addons-load');
			do_action('aec-addons-init');
			$this->pluginDir = apply_filters('aec-addons-plugindir', $this->pluginDir);
			$this->colorboxScriptName = apply_filters('aec-colorbox-script-name', 'colorbox');
			$this->colorboxStyleName = apply_filters('aec-colorbox-style-name', 'colorbox');
			
			//If a user isn't logged in and has no comment cookie, don't load the plugin either
			if (!is_user_logged_in()) {
				$cookieloaded = false;
				foreach($_COOKIE as $value => $key){
					if (strstr($value,'WPAjaxEditCommentsComment')){         
						$cookieloaded = true; break;			
					}
				}
				if (!$cookieloaded) {
					add_action("wp_print_styles", array(&$this,"load_frontend_css"));
					add_action('wp_print_scripts', array(&$this,'load_frontend'),1000);
					return;
				}
			}
			
			
			$this->initialize_errors();
	
			$this->skip = false;
			//css
			add_action("wp_print_styles", array(&$this,"load_frontend_css"));
			add_action("wp_print_styles", array(&$this,"add_css"));
			add_action('admin_print_styles', array(&$this,"add_css")); 
			add_action('admin_print_styles-toplevel_page_wpaec', array(&$this, 'add_admin_panel_css'), 1000);
			add_action('admin_print_styles-aec_page_wpaecsupport', array(&$this, 'add_admin_panel_css'), 1000);
			//JavaScript
			add_action('admin_print_scripts', array(&$this,'add_post_scripts'),1000); 
			add_action('wp_print_scripts', array(&$this,'add_post_scripts'),1000);
			add_action('admin_print_scripts-plugins.php', array(&$this, 'add_admin_scripts_upgrade'), 1000);
			add_action('admin_print_scripts-toplevel_page_wpaec', array(&$this, 'add_admin_panel_scripts'), 1000);
			add_action('admin_print_scripts-aec_page_wpaecsupport', array(&$this, 'add_admin_panel_scripts_support'), 1000);
			
			//Ajax stuff
			add_action( 'wp_ajax_upgradecheck', array(&$this,'upgrade_check'));
			
			//Initialization stuff
			
			//Admin options
			add_action('admin_menu', array(&$this,'add_admin_pages'));
			
			//Check for updates
			//add_action('update_option_update_plugins', array(&$this, 'check_updates')); //for WP 2.7
			//add_action('update_option__transient_update_plugins', array(&$this, 'check_updates')); //for WP 2.8
			add_action('after_plugin_row_wp-ajax-edit-comments/wp-ajax-edit-comments.php', array(&$this, 'plugin_row') );
     		add_action('install_plugins_pre_plugin-information', array(&$this, 'display_changelog'));
			if (!is_feed()) {
				//Yay, filters.
				add_filter('comment_excerpt', array(&$this, 'add_edit_links'), '1000');
				//add_filter('get_comment_date', array(&$this, 'add_date_spans'), '1000');
				//add_filter('get_comment_time', array(&$this, 'add_time_spans'), '1000');
				add_filter('comment_text', array(&$this, 'add_edit_links'), '1000'); //Low priority so other HTML can be added first
				add_filter('thesis_comment_text', array(&$this, 'add_edit_links'),'1000'); //For Thesis (todo - remove when necessary)
				add_filter('get_comment_author_link', array(&$this, 'add_author_spans'), '1000'); //Low priority so other HTML can be added first
			}
			
			//* Begin Localization Code */
			$wp_ajax_edit_comments_locale = get_locale();
			$wp_ajax_edit_comments_mofile = WP_CONTENT_DIR . "/plugins/wp-ajax-edit-comments/languages/" . $this->localizationName . "-". $wp_ajax_edit_comments_locale.".mo";
			load_textdomain($this->localizationName, $wp_ajax_edit_comments_mofile);
			
			//Do upgrade stuff
			if (current_user_can("administrator")) {
				$this->check_periodic_updates();
				$option = $this->adminOptions;
				if (is_object($option['new_version'])) {
					if(!version_compare($this->version, $option['new_version']->new_version, '>=')){
						add_filter('site_transient_update_plugins', array(&$this, 'update_plugins_filter'),1000);
					}
				}
			}
		//* End Localization Code */
		}//end function init
		function update_plugins_filter($value) {
			$plugin_name = "wp-ajax-edit-comments/wp-ajax-edit-comments.php";
			$value->response[$plugin_name] = $this->adminOptions['new_version'];
			return $value;
		}
		/* is_comment_owner - Checks to see if a user can edit a comment */
		/* Parameters - postID */
		/* Returns - true if user is comment owner, false if not*/
		function is_comment_owner($postID = 0) {
			if (!isset($this->admin)) { $this->admin = false; }
			if ($this->admin) { return true; }
			//Check to see if user is admin of the blog
			if (current_user_can('edit_users')) {
				$this->admin = true;
				return true;
			} elseif( current_user_can( 'edit_page', $postID) || current_user_can( 'edit_post', $postID)) {
				$this->admin = false;
				return true;
			}
			return false;
		}
		/* is_logged_in - Checks to see if the user (non-admin) is logged in 
		Parameters - $userID
		Returns true if logged in, false if not */
		function is_logged_in($userID = 0) {
			if ($this->get_user_id() == $userID) {
				return true;
			} else { 
				return false;
			}
		}
		/*load_pages - Checks query variables and loads the appropriate page */
		function load_pages() {
			$pagepath = WP_CONTENT_DIR . '/plugins/wp-ajax-edit-comments/php/';
			$queryvar = get_query_var('aec_page');
			if (empty($queryvar)) 
				return;
				
			global $wp_query;
			$wp_query->is_home = false;
			switch($queryvar) {
				case 'comment-editor.php':
					include($pagepath . 'comment-editor.php');
					exit;
					break;
				case 'ajax-processor.php':
					include($pagepath . 'ajax-processor.php');
					exit;
					break;
				case 'email.php':
					include($pagepath . 'email.php');
					exit;
					break;
				case 'move-comment.php':
					include($pagepath . 'move-comment.php');
					exit;
					break;
				case 'blacklist-comment.php':
					include($pagepath . 'blacklist-comment.php');
					exit;
					break;
				case 'comment-popup.php':
					include($pagepath . 'comment-popup.php');
					exit;
					break;
				case 'request-deletion.php':
					include($pagepath . 'request-deletion.php');
					exit;
					break;
			}
		}
		/* moderate_comment - Marks a comment as unapproved 
		Parameters - $commentID, $postID
		Returns - 1 if successful, a string error message if not */
		function moderate_comment($commentID=0, $postID = 0) {
			if ($this->is_comment_owner($postID)) {
				$status = wp_set_comment_status($commentID, 'hold')? "1" : 'moderate_failed';
				return $status;
			} else {
				return 'moderate_failed_permission';
			}
		}
		/* move_comment - Moves a comment from an old post to a new post
		Parameters - $commentID, $oldPostID, $newPostID
		Returns nothing */
		function move_comment($commentID=0, $oldPostID=0, $newPostID=0) {
			global $wpdb, $post;
			$response = new WP_Ajax_Response();
			
			//Return if not comment owner and if posts are the same
			if ($oldPostID == $newPostID || !$this->is_comment_owner($newPostID)) { 
				$response->add(array(
				'what' => 'nochange',
				'data' => "nochange"
				));
				$response->send();
				return;
			}
			
			//Update the comment with the new post number
			$wpdb->update($wpdb->comments, array('comment_post_ID' => intval($newPostID)), array('comment_ID' => intval($commentID)));
			
			//Update the posts' comment count
			@wp_update_comment_count_now(intval($newPostID));
			@wp_update_comment_count_now(intval($oldPostID));
			
			$posts = get_posts("include=$oldPostID,$newPostID");
			foreach ($posts as $post) {
				if ($post->ID == $oldPostID) {
					$response->add(array(
						'what' => 'old_id',
						'id' => $newPostID,
						'old_id' => $oldPostID,
						'supplemental' => array(
							'title' => the_title('','',false),
							'permalink' => apply_filters('the_permalink', get_permalink()),
							'comments' => $post->comment_count
						)
					));
				} else {
					$response->add(array(
						'what' => 'new_id',
						'id' => $oldPostID,
						'old_id' => $newPostID,
						'supplemental' => array(
							'title' => the_title('','',false),
							'permalink' => apply_filters('the_permalink', get_permalink()),
							'comments' => $post->comment_count
						)
					));
				}
			}
			
			return $response;
		}
		/* remove_nofollow - Removes no-follow from comment links
		Parameters - $text - The comment text
		Returns altered text
		Credits:  http://www.allpassionmarketing.com*/
		function remove_nofollow($text = '') {
			$text = preg_replace("/(<a[^>]*[^\s])(\s*nofollow\s*)/i", "$1", $text);
			$text = preg_replace("/(<a[^>]*[^\s])(\s*rel=\"\s*\")/i", "$1", $text);
			return $text;
		}
		/* request_Deletion - Sends a request to admin for comment removal
		Parameters - $commentID, $postID
		Returns error or response */
		function request_deletion($commentID = 0, $postID = 0, $message) {
			$canedit = $this->can_edit($commentID, $postID);
			if (is_string($canedit)) {
				return 'request_deletion_failed';
			}
			if (wp_set_comment_status($commentID, 'hold') || wp_get_comment_status($commentID) == "unapproved") {
				$this->request_deletion_message($commentID, $message);
				
				//Get the comment and remove the cookie
				$comment = get_comment($commentID);
				$hash = md5($comment->comment_author_IP . $comment->comment_date_gmt);
				$GLOBALS[$this->cookieName . $commentID . $hash] = ''; //for CFORMS compatibility
				setcookie($this->cookieName . $commentID . $hash, '', time() - 3600, COOKIEPATH,COOKIE_DOMAIN); //removes the cookie
				return 1;
			} else {
				return 'request_deletion_failed';
			}
		}
		function request_deletion_message($commentID = 0, $message) {
			$comment = get_comment($commentID);
			$post    = get_post($comment->comment_post_ID);
			$notify_message  = sprintf( __('A commenter requests deletion of a comment on your post #%1$s "%2$s".  The comment has been moved to the moderation queue.', $this->localizationName), $comment->comment_post_ID, $post->post_title ) . "\r\n";
			$notify_message  .= sprintf( __('The reason given is: ' . $message, $this->localizationName), $comment->comment_post_ID, $post->post_title ) . "\r\n\r\n";
			$notify_message .= sprintf( __('E-mail : %s', $this->localizationName), $comment->comment_author_email ) . "\r\n";
			$notify_message .= sprintf( __('URL    : %s', $this->localizationName), $comment->comment_author_url ) . "\r\n";
			$notify_message .= sprintf( __('Whois  : http://ws.arin.net/cgi-bin/whois.pl?queryinput=%s', $this->localizationName), $comment->comment_author_IP ) . "\r\n";
			$notify_message .= get_permalink($comment->comment_post_ID) . "#comments\r\n\r\n";
			$notify_message .= sprintf( __('Delete it: %s', $this->localizationName), admin_url("comment.php?action=cdc&c=$commentID") ) . "\r\n";
			$notify_message .= sprintf( __('Approve it: %s', $this->localizationName),  admin_url("comment.php?action=mac&c=$commentID") ) . "\r\n";
			$notify_message .= sprintf( __('Spam it: %s', $this->localizationName), admin_url("comment.php?action=cdc&dt=spam&c=$commentID") ) . "\r\n";
			$email = get_option('admin_email');
			$blogname = get_option('blogname');
			$from = "From: \"$blogname\" <$email>";
			$reply_to = "Reply-To: $email";
			$message_headers = "$from\n"
				. "Content-Type: text/plain; charset=\"" . get_option('blog_charset') . "\"\n";
			$message_headers .= $reply_to . "\n";
			$subject = sprintf( __('Request for Comment Deletion: "%2$s"',$this->localizationName), $blogname, $post->post_title );
			@wp_mail($email, $subject, $notify_message, $message_headers);
		}
		/* save_comment - Saves a new comment
		Parameters - $commentID, $postID, $commentarr (comment array)
		Returns errors or response*/
		function save_comment($commentID, $postID, $commentarr) {
			global $wpdb;
			$response = new WP_Ajax_Response();
			//Save the old comment and build an undo spot
			$undoComment = get_comment($commentID, ARRAY_A);
			//Make sure the comment has something in it
			if ('' == $commentarr['comment_content'] || $commentarr['comment_content'] == "undefined") {
				$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => $this->get_error('content_empty')
				));
				$response->send(); return;
			}
			//Check to see if user can edit
			$message = $this->can_edit($commentID, $postID);
			if (is_string($message)) {
				$response->add( array(
					'what' => 'error',
					'id' => $commentID,
					'data' => $this->get_error($message)
				));
				$response->send(); return;
			}
			
			
			//Sanity checks
			if (!$this->is_comment_owner($postID)) {
				//Make sure required fields are filled out
				if ( get_option('require_name_email') && ((6 > strlen($commentarr['comment_author_email']) && $this->can_edit_email($commentID, $postID)) || ('' == $commentarr['comment_author'] && $this->can_edit_name($commentID, $postID)))) {
					$response->add( array(
						'what' => 'error',
						'id' => $commentID,
						'data' => $this->get_error('required_fields')
					));
					$response->send(); return;
				}
			}// end comment_owner check
			//Make sure the e-mail is valid - Skip if pingback or trackback
			if (!($this->admin  && empty($commentarr['comment_author_email']))) {
				if (!is_email($commentarr['comment_author_email']) && $commentarr['comment_type'] != "pingback" && $commentarr['comment_type'] != "trackback") {
					if (!get_option('require_name_email') && empty($commentarr['comment_author_email'])) {
					
					} else {
						if ($this->can_edit_email($commentID, $postID)) {
							$response->add( array(
								'what' => 'error',
								'id' => $commentID,
								'data' => $this->get_error('invalid_email')
							));
							$response->send(); return;
						}
					}
				}
			}
			if (strtolower(get_option('blog_charset')) != 'utf-8') { @$wpdb->query("SET names 'utf8'");} //comment out if getting char errors
			
			//Save the comment
			$commentarr['comment_ID'] = (int)$commentID;
			$commentapproved = $commentarr['comment_approved'];
			//Do some comment checks before updating
			if (!$this->is_comment_owner($postID)) {
				//Preserve moderation/spam setting.  Only check approved comments
				if ($commentarr['comment_approved'] == 1) {
					// Everyone else's comments will be checked.
					if ( check_comment($commentarr['comment_author'], $commentarr['comment_author_email'], $commentarr['comment_author_url'], $commentarr['comment_content'], $commentarr['comment_author_IP'], $commentarr['comment_agent'], $commentarr['comment_type'])) 
						$commentarr['comment_approved'] = 1;
					else
						$commentarr['comment_approved'] = 0;
				}
					
				if ( wp_blacklist_check($commentarr['comment_author'], $commentarr['comment_author_email'], $commentarr['comment_author_url'], $commentarr['comment_content'], $commentarr['comment_author_IP'], $commentarr['comment_agent']) )
					$commentarr['comment_approved'] = 'spam';
			}
			
			
			//Update the comment
			wp_update_comment($commentarr);
			
			//If spammed, return error
			if (!$this->admin && $commentarr['comment_approved'] === 'spam') {
				$response->add( array(
						'what' => 'error',
						'id' => $commentID,
						'data' => $this->get_error('comment_marked_spam')
					));
				$response->send(); return;
			}
			
			//If moderated, return error
			if ($commentarr['comment_approved'] == 0 && $commentapproved != 0) {
				$response->add( array(
						'what' => 'error',
						'id' => $commentID,
						'data' => $this->get_error('comment_marked_moderated')
					));
				$response->send(); return;
			}
			
			//For security, get the new comment
			global $comment;
			$comment = get_comment($commentID);
			//Check for spam
			if (!$this->is_comment_owner($postID)) {
				if($this->check_spam($commentID, $postID)) {
					$response->add( array(
						'what' => 'error',
						'id' => $commentID,
						'data' => $this->get_error('comment_marked_spam')
					));
					$response->send(); return;
				};
			}
			//Do actions after a comment has successfully been edited
			do_action_ref_array('wp_ajax_comments_comment_edited', array(&$commentID, &$postID));
			//Condition the data for returning
			do_action('wp_ajax_comments_remove_content_filter');
			//Get undo data
			if ($this->admin) {
				$oldComment = $this->adminOptions['undo'];
				$undo = $this->build_undo_url("undoedit", $commentID, $postID, __('Comment successfully saved',$this->localizationName)); 				
			} else {
				$undo = '';
			}
			$approve_count = get_comment_count($postID);
			$comment_count = get_comment_count();
			$response->add(array(
					'what' => 'content',
					'id' => $commentID,
					'supplemental' => array(
						'content' => stripslashes(apply_filters('comment_text',apply_filters('get_comment_text',$this->encode($comment->comment_content)))),
						'comment_author' => stripslashes(apply_filters('comment_author', apply_filters('get_comment_author', $this->encode($comment->comment_author)))),
						'comment_author_url' => stripslashes(apply_filters('comment_url', apply_filters('get_comment_author_url', $comment->comment_author_url))),
						'comment_date' =>  get_comment_date('F jS, Y'),
						'comment_time' => get_comment_time(),
						'comment_approved' => $comment->comment_approved,
						'old_comment_approved' => $oldComment['comment_approved'],
						'undo_comment_approved' => $undoComment['comment_approved'],
						'approve_count' => $approve_count['approved'],
						'moderation_count' => $comment_count['awaiting_moderation'],
						'spam_count' => $comment_count['spam'],
						'comment_links' => $this->build_admin_links($commentID, $postID),
						'undo' => $undo
					)
			));
			return $response;
		} //save_comment
		/* show_affiliate_link - Returns true if affiliate links should be displayed.  False if not*/
		function show_affiliate_link() {
			$options = $this->adminOptions;
			if (empty($options['affiliate_id']) || $options['affiliate_show'] == "false") 
				return false;
			return true;
		}
		/* spam_comment - Marks a comment as spam or de-spams a comment
		Parameters - $commentID, $postID
		Returns - 1 if successful, a string error message if not */
		function spam_comment($commentID = 0, $postID = 0) {
			if ($this->is_comment_owner($postID)) {
				$status = wp_set_comment_status($commentID, 'spam')? "1" : 'comment_spam_failed';
				return $status;
			} else {
				return 'comment_spam_failed_permission';
			}
		}
		//Checks for upgrades in the plugin_row 
		function upgrade_check() {
			check_ajax_referer('upgradecheck');
			
			$response = new WP_Ajax_Response();
			//Getting version number
			$version_info = $this->check_updates();
			if (!is_array($version_info)) {
				$response->add(array(
						'what' => 'upgraderesponse',
						'data' => __($this->get_error($version_info), $this->localizationName)
						)
					);
					$response->send();
					die('');
			}
			
			if ($version_info['is_valid_key'] == '0') {
					//User hasn't entered a valid key and/or the customer doesn't have upgrade capabilities
					$response->add(array(
						'what' => 'upgraderesponse',
						'data' => sprintf(__("An upgrade (Version %s) is available.  Please visit your", $this->localizationName) . " <a href='http://www.ajaxeditcomments.com/forums/members/'>" . __("member's section", $this->localizationName) . ".</a>.", $version_info['version'])
						)
					);
					$response->send();
					die('');
			} else {
				$plugin = 'wp-ajax-edit-comments/wp-ajax-edit-comments.php';
				$upgrade_url =  wp_nonce_url(admin_url("update.php?action=upgrade-plugin&amp;plugin=$plugin"), 'upgrade-plugin_' . $plugin);
				$response->add(array(
						'what' => 'upgraderesponse',
						'data' => __('There is a new version of WP Ajax Edit Comments available.', $this->localizationName) . " -- " . "<a href='$upgrade_url'>" . __('Upgrade automatically', $this->localizationName) . '</a>.'
						)
					);
					$response->send();
					die('');
			}
			exit();
		} //end function upgrade_check
		/*BEGIN UPDATE FUNCTIONS*/
		function affiliate_id_check($id = 0) {
			$body = "affiliate_id=$id";
			$options = array('method' => 'POST', 'timeout' => 3, 'body' => $body);
			$options['headers'] = array(
					'Content-Type' => 'application/x-www-form-urlencoded; charset=' . get_option('blog_charset'),
					'Content-Length' => strlen($body),
					'User-Agent' => 'WordPress/' . get_bloginfo("version"),
					'Referer' => get_bloginfo("url")
			);

			$raw_response = wp_remote_request($this->aec_url . "/affiliateid.php?" . $this->get_remote_request_params(), $options);
			if ( is_wp_error( $raw_response ) || 200 != $raw_response['response']['code'])
					return -1;
			else
			{
					return array("is_valid_id" => $raw_response['body']);
			}
		}
		//Check for a valid authentication key
		function auth_key_check($key = '') {
			//Getting version number
			if (empty($key)) {
				$key = $this->get_key();
			}
			$body = "key=$key&blogurl=" .urlencode(get_bloginfo('wpurl')) ;
			$options = array('method' => 'POST', 'timeout' => 3, 'body' => $body);
			$options['headers'] = array(
					'Content-Type' => 'application/x-www-form-urlencoded; charset=' . get_option('blog_charset'),
					'Content-Length' => strlen($body),
					'User-Agent' => 'WordPress/' . get_bloginfo("version"),
					'Referer' => get_bloginfo("url")
			);

			$raw_response = wp_remote_request($this->aec_url . "/authkey.php?" . $this->get_remote_request_params(), $options);

			if ( is_wp_error( $raw_response ) || 200 != $raw_response['response']['code'])
					return -1;
			else
			{
					$ary = explode("||", $raw_response['body']);
					return array("is_valid_key" => $ary[0], "is_valid_site" => $ary[1]);
			}
		}
		//Attempts to remove an auth key from a wordpress site
		function auth_key_remove($key = '') {
			$body = "key=$key&blogurl=" .urlencode(get_bloginfo('wpurl')) ;
			$options = array('method' => 'POST', 'timeout' => 3, 'body' => $body);
			$options['headers'] = array(
					'Content-Type' => 'application/x-www-form-urlencoded; charset=' . get_option('blog_charset'),
					'Content-Length' => strlen($body),
					'User-Agent' => 'WordPress/' . get_bloginfo("version"),
					'Referer' => get_bloginfo("url")
			);

			$raw_response = wp_remote_request($this->aec_url . "/authkeyremove.php?" . $this->get_remote_request_params(), $options);

			if ( is_wp_error( $raw_response ) || 200 != $raw_response['response']['code'])
					return -1;
			else
			{
					return $raw_response['body'];
			}
		}
		//Performs a periodic upgrade check to see if the plugin needs to be upgraded or not
		function check_periodic_updates() {
			$options = $this->adminOptions;
			$last_update_check = $options['last_update'];
			$twelve_hours = 43200;
			if((time() - $last_update_check) > $twelve_hours){
					$this->check_updates();
					$this->adminOptions['last_update'] = time();
					$this->save_admin_options();
			}
		}
		function get_remote_request_params(){
        global $wpdb;
        return sprintf("of=AjaxEditComments&key=%s&v=%s&wp=%s&php=%s&mysql=%s&blogurl=%s", urlencode($this->get_key()), urlencode($this->version), urlencode(get_bloginfo("version")), urlencode(phpversion()), urlencode($wpdb->db_version()),urlencode(get_bloginfo('wpurl')));
    }//end periodic_updates
		//Checks for plugin updates
		//Returns an error code or array if no error
		function check_updates() { 
			//only check updates on the admin side
			if(!is_admin())
					return 'upgrade_check_failed';
		
			$plugin_name = "wp-ajax-edit-comments/wp-ajax-edit-comments.php";
			$option = function_exists('get_transient') ? get_transient("update_plugins") : get_option("update_plugins");
			$aec_option = $option->response[$plugin_name];
			
			if(empty($aec_option))
					$option->response[$plugin_name] = new stdClass();
			
			//Getting version number
			$version_info = $this->get_version_info();
			
			if ($version_info == -1)
					return 'upgrade_check_failed';
			
			//No upgrade available
			if(version_compare($this->version, $version_info["version"], '>=')){
					return 'upgrade_check_none';
			}
			else{
					$option->response[$plugin_name]->url = "http://www.ajaxeditcomments.com";
					$option->response[$plugin_name]->slug = "wp-ajax-edit-comments";
					$option->response[$plugin_name]->package = $version_info["url"];
					$option->response[$plugin_name]->new_version = $version_info["version"];
					$option->response[$plugin_name]->id = "0";
					$this->adminOptions['new_version'] = $option->response[$plugin_name];
					$this->save_admin_options();
					
			}
			
			//Setting transient data (WP 2.8)
			if ( function_exists('set_transient') && !$this->has_set_transient){
					$this->has_set_transient = true;
					set_transient("update_plugins", $option);
			}
			
			//Setting option (WP 2.7)
			if(!$this->has_set_option){
					$this->has_set_option = true;
					update_option("update_plugins", $option);
			}
			return $version_info;
		} //end function check_updates
		//Displays current version details on Plugin's page
    function display_changelog(){
        if($_REQUEST["plugin"] != "wp-ajax-edit-comments")
            return;

        $key = $this->get_key();
        $body = "key=$key";
        $options = array('method' => 'POST', 'timeout' => 3, 'body' => $body);
        $options['headers'] = array(
            'Content-Type' => 'application/x-www-form-urlencoded; charset=' . get_option('blog_charset'),
            'Content-Length' => strlen($body),
            'User-Agent' => 'WordPress/' . get_bloginfo("version"),
            'Referer' => get_bloginfo("url")
        );

        $raw_response = wp_remote_request($this->aec_url . "/changelog.php?" . $this->get_remote_request_params(), $options);

        if ( is_wp_error( $raw_response ) || 200 != $raw_response['response']['code']){
            $page_text = __("Oops!! Something went wrong.<br/>Please try again or <a href='http://www.ajaxeditcomments.com/contact/'>contact us</a>.", $this->localizationName);
        }
        else{
            $page_text = $raw_response['body'];
            if(substr($page_text, 0, 10) != "<!--AEC-->")
                $page_text = "";
        }
        echo stripslashes($page_text);
        exit;
    }//end display_changelog
		//Returns an API key
		function get_key() {
			$options = $this->adminOptions;
			return $options['auth_key'];
		}
		function get_version_info(){
        //Getting version number
        $key = $this->get_key();
        $body = "key=$key";
        $options = array('method' => 'POST', 'timeout' => 3, 'body' => $body);
        $options['headers'] = array(
            'Content-Type' => 'application/x-www-form-urlencoded; charset=' . get_option('blog_charset'),
            'Content-Length' => strlen($body),
            'User-Agent' => 'WordPress/' . get_bloginfo("version"),
            'Referer' => get_bloginfo("url")
        );

        $raw_response = wp_remote_request($this->aec_url . "/version.php?" . $this->get_remote_request_params(), $options);

        if ( is_wp_error( $raw_response ) || 200 != $raw_response['response']['code'])
            return -1;
        else
        {
            $ary = explode("||", $raw_response['body']);
            return array("is_valid_key" => $ary[0], "version" => $ary[1], "url" => $ary[2]);
        }
    } //end get_version_info
		function plugin_row($plugin_name){

        $key = $this->get_key();
        $version_info = $this->get_version_info();

        if(!$version_info["is_valid_key"]){

            $plugin_name = "wp-ajax-edit-comments/wp-ajax-edit-comments.php";

            $new_version = version_compare($this->version, $version_info["version"], '<') ? __('There is a new version of WP Ajax Edit Comments available.', $this->localizationName) .' <a class="thickbox" title="WP Ajax Edit Comments" href="plugin-install.php?tab=plugin-information&plugin=wp-ajax-edit-comments&TB_iframe=true&width=640&height=808">'. sprintf(__('View version %s Details', $this->localizationName), $version_info["version"]) . '</a>. ' : '';
        }
		$upgrade_url = clean_url(wp_nonce_url(admin_url( 'admin-ajax.php') . "?&action=upgradecheck", "upgradecheck"));
        echo '</tr><tr class="plugin-update-tr"><td colspan="5" class="plugin-update"><div class="update-message">' . $new_version . "<a id='aeccheckupdates' href='$upgrade_url'>" . __('Check for upgrades', $this->localizationName) . '</a>&nbsp;&nbsp;<span id="aeccheckupdatesmessage"></span></div></td>';
    } //end plugin_row
		
		
		
		
		/*END UPDATE FUNCTIONS*/
		/*BEGIN UTILITY FUNCTIONS - Grouped by function and not by name */
		function add_admin_pages(){
				add_menu_page( 'Ajax Edit Comments', 'AEC', 9, 'wpaec', array(&$this, 'print_admin_page'));
				do_action('aec-addon-menus');
				add_submenu_page( 'wpaec', 'Support', 'Support', 9, 'wpaecsupport', array(&$this, 'print_admin_support_subpage'));
		}
		//Removes the div and various links from a comment 
		function comment_filter() {
			$this->skip = true;
		}
		//Provides the interface for the admin pages
		function print_admin_page() {
			include dirname(__FILE__) . '/php/admin-panel.php';
		}
		//Provides the interface for admin subpages
		function print_admin_support_subpage() {
			include dirname(__FILE__) . '/php/admin-panel-support.php';
		}
		//Returns an array of admin options
		function get_admin_options() {
			
			if (empty($this->adminOptions)) {
				$adminOptions = array(
					'allow_editing' => 'true',
					'allow_editing_after_comment' => 'true',
					'minutes' => '5', 
					'edit_text' => '', 
					'show_timer' => 'true',
					'show_pages' => 'true',
					'spam_text' => __('Your edited comment was marked as spam.  If this is in error, please contact the admin.', $this->localizationName),
					'email_edits' => 'false',
					'number_edits' => '0',
					'spam_protection' => 'akismet',
					'registered_users_edit' => 'false',
					'registered_users_name_edit' => 'true',
					'registered_users_email_edit' => 'false',
					'registered_users_url_edit' => 'true',
					'use_mb_convert' => 'true',
					'allow_name_editing' => 'true',
					'allow_email_editing' => 'false',
					'allow_url_editing' => 'true',
					'allow_css' => 'true',
					'allow_css_editor' => 'true',
					'clear_after' => 'true',
					'javascript_scrolling' => 'true',
					'comment_display_top' => 'false',
					'undo' => '',
					'icon_display' => 'dropdown',
					'icon_set' => 'circular',
					'use_rtl' => 'false',
					'last_update' => time(),
					'affiliate_id' => 0,
					'auth_key' => '',
					'affiliate_text' => __('Get your own comment editor for your WordPress website.  Try [url]Ajax Edit Comments[/url] today!', $this->localizationName),
					'affiliate_show' => 'false',
					'scripts_in_footer' => 'false',
					'compressed_scripts' => 'true',
					'drop_down' => array(),
					'classic' => array(),
					'disable_trackbacks' => 'false',
					'disable_nofollow' => 'false',
					'disable_selfpings'=> 'false',
					'delink_content' => 'false',
					'after_deadline_posts' => 'true',
					'after_deadline_popups' => 'true',
					'expand_popups' => 'true',
					'expand_posts' => 'true',
					'use_wpload' => 'false',
					'allow_registeredediting' => 'true',
					'atdlang' => 'en',
					'request_deletion_behavior' => 'request',
					'new_version' => '',
					'allow_editing_editors' => 'true'
				
				);
				$options = get_option($this->adminOptionsName);
				if (!empty($options)) {
					foreach ($options as $key => $option) {
						if (array_key_exists($key, $adminOptions)) {
							$adminOptions[$key] = $option;
						}
					}
				}
				//Update the array for dropdown items
				$dropdown = array(
							'dropdownapprove' => array('id' => 'dropdownapprove','column' => '0', 'position' => '0', 'enabled' => '1', 'text' =>__('Approve', $this->localizationName)), 
							'dropdownmoderate' => array('id' => 'dropdownmoderate','column' => '0','position' => '1','enabled' =>'1','text' =>__('Moderate', $this->localizationName)),
							'dropdownspam' => array('id' => 'dropdownspam','column' => '0','position' => '2','enabled' =>'1','text' => __('Spam', $this->localizationName)),
							'dropdowndelete' => array('id' => 'dropdowndelete','column' => '0','position' => '3','enabled' =>'1','text' =>__('Delete', $this->localizationName)),
							'dropdowndelink' => array('id' => 'dropdowndelink','column' => '1','position' => '0','enabled' =>'1','text' =>__('De-link', $this->localizationName)),
							'dropdownmove' => array('id' => 'dropdownmove','column' => '1','position' => '1','enabled' =>'1','text' =>__('Move', $this->localizationName)),
							'dropdownemail' => array('id' => 'dropdownemail','column' => '1','position' => '2','enabled' =>'1','text' =>__('E-mail', $this->localizationName)),
							'dropdownblacklist' =>  array('id' => 'dropdownblacklist','column' => '1','position' => '3','enabled' =>'1','text' =>__('Blacklist', $this->localizationName)));
				foreach ($dropdown as $item => $value) {
					if (!array_key_exists($item, $adminOptions['drop_down'])) {
						$adminOptions['drop_down'][$item] = $value;
					}
				}
				foreach ($adminOptions['drop_down'] as $item => $value) {
					if (!array_key_exists($item, $dropdown)) {
						unset($adminOptions['drop_down'][$item]);
					}
				}
				//Update the array for classic items
				$classic = array(
							'edit' => array('id' => 'edit','column' => '0', 'enabled' => '1', 'text' =>__('Edit', $this->localizationName)),
							'approve' => array('id' => 'approve','column' => '1', 'enabled' => '1', 'text' =>__('Approve', $this->localizationName)), 
							'moderate' => array('id' => 'moderate','column' => '2','enabled' =>'1','text' =>__('Moderate', $this->localizationName)),
							'spam' => array('id' => 'spam','column' => '3','enabled' =>'1','text' => __('Spam', $this->localizationName)),
							'delete' => array('id' => 'delete','column' => '4','enabled' =>'1','text' =>__('Delete', $this->localizationName)),
							'delink' => array('id' => 'delink','column' => '5','enabled' =>'1','text' =>__('De-link', $this->localizationName)),
							'move' => array('id' => 'move','column' => '6','enabled' =>'1','text' =>__('Move', $this->localizationName)),
							'email' => array('id' => 'email','column' => '7','enabled' =>'1','text' =>__('E-mail', $this->localizationName)),
							'blacklist' =>  array('id' => 'blacklist','column' => '8','enabled' =>'1','text' =>__('Blacklist', $this->localizationName)));
				foreach ($classic as $item => $value) {
					if (!array_key_exists($item, $adminOptions['classic'])) {
						$adminOptions['classic'][$item] = $value;
					}
				}
				foreach ($adminOptions['classic'] as $item => $value) {
					if (!array_key_exists($item, $classic)) {
						unset($adminOptions['classic'][$item]);
					}
				}
				//Save the options
				$this->adminOptions = $adminOptions;
				$this->save_admin_options();								
			}
			return $this->adminOptions;
		}
		//Returns an array of "all" user options
		function get_all_user_options() {
			if (!function_exists("get_currentuserinfo")) { return; }
			if (empty($this->userOptions)) {
				$user_email = $this->get_user_email(); 
				$defaults = array(
				'comment_editing' => 'true', 
				'admin_editing' => 'false'
				);
				$this->userOptions = get_option($this->userOptionsName);
				if (!isset($this->userOptions)) {
					$this->userOptions = array();
				}
				//See if an older version doesn't match the new defaults
				if (empty($this->userOptions[$user_email])) {
					$this->userOptions[$user_email] = $defaults;
				}	elseif(!is_array($this->userOptions[$user_email])) {
					$this->userOptions[$user_email] = $defaults;
				} else {
						foreach ($this->userOptions[$user_email] as $key => $option) {
							$defaults[$key] = $option;								
						}
						$this->userOptions[$user_email] = $defaults;
				}
				$this->save_admin_options();
			}
			return $this->userOptions;
		}
		//Returns a logged-in user's e-mail address
		function get_user_email() {
			global $user_email;
			if (!function_exists("get_currentuserinfo")) { return ''; }
			if (empty($user_email)) {get_currentuserinfo();} //try to get user info
			if (empty($user_email)) { return '0'; } //Can't get user info, so return empty string
			return $user_email;
		}
		// Returns a logged-in user's ID
		function get_user_id() {
			global $user_ID;
			if (!function_exists("get_currentuserinfo")) { return "-1"; }
			if (empty($user_ID)) {get_currentuserinfo();} //try to get user info
			if (empty($user_ID)) { return '-1'; } //Can't get user info, so return empty string
			return $user_ID;
		}
		
		//Returns an array of an individual's options
		function get_user_options() {
			if (empty($this->userOptions)) { $this->userOptions = $this->get_all_user_options(); }
			return $this->userOptions[$this->get_user_email()];
		}
		//Saves Ajax Edit Comments settings for admin and admin users
		function save_admin_options(){
			if (!empty($this->adminOptions)) {
				update_option($this->adminOptionsName, $this->adminOptions);
			}
			if (!empty($this->userOptions)) {
				update_option($this->userOptionsName, $this->userOptions);
			}
		}
		//Checks for script addition on single or page posts
		function add_post_scripts() {
			if (is_single()) {
				$this->add_scripts();
			} elseif (is_page() && $this->adminOptions['show_pages'] == 'true') {
				$this->add_scripts();
			} elseif (is_admin()) {
				$this->add_admin_scripts();
			} 
		}
		function add_admin_scripts_upgrade() {
			$this->js_localize('aec_check_upgrades', array('checking' => __('Checking...', $this->localizationName),'checkupgrades' => __('Check for Upgrades',$this->localizationName)));
			wp_enqueue_script('aec-check-upgrades', $this->pluginDir . '/js/check-upgrades.js', array('jquery', 'wp-ajax-response'), '1.0', true);
		}
		//Adds CSS for the admin panel interface
		function add_admin_panel_css() {
			wp_enqueue_style('aecadminpanel', $this->pluginDir.'/css/admin-panel.css');
			wp_enqueue_style('aecadminpaneltabber', $this->pluginDir.'/css/tabber.css', array('aecadminpanel'));
		}
		//Adds scripts for the admin panel interface
		function add_admin_panel_scripts() {
			wp_enqueue_script('jquery-tools', $this->pluginDir . '/js/jquery.tools.min.js', array('jquery',"jquery-ui-sortable"), '1.0', true);
			wp_enqueue_script('admin-panel', $this->pluginDir . '/js/admin-panel.js', array('jquery-tools'), '1.0', true);
		}
		//Add scripts for the admin panel setup interface
		function add_admin_panel_scripts_support() {
			wp_enqueue_script('jquery-tools', $this->pluginDir . '/js/jquery.tools.min.js', array('jquery'), '4.1', true);
			wp_enqueue_script('aec-tab-config', $this->pluginDir . '/js/tab-config.js', array('jquery-tools'), '4.1', true);
			$this->js_localize('aecsupport', array('show' => __('show', $this->localizationName),'hide' => __('hide',$this->localizationName)));
			wp_enqueue_script('aecsupport', $this->pluginDir . '/js/support.js', array('jquery'), '4.1', true);
		}
		/* Private - Adds JavaScript in the admin panel if admin has enabled the option */
		function add_admin_scripts() {
			//Page detection for other plugin authors
			switch (basename($_SERVER['SCRIPT_FILENAME'])) {
				case "edit-comments.php":
					break;
				case "edit.php":
					if (isset($_GET['p'])) { break; }
				default:
					if (preg_match( '/wp-admin\/index\.php$/',$_SERVER['PHP_SELF'] )) {
						break;
					}
				return;
			}
			$options = $this->get_user_options();
			if ($options['admin_editing'] == 'true') { return; }
			$this->add_scripts();
		}
		//Adds the appropriate scripts to WordPress
		function add_scripts(){
			global $post;
			$options = $this->adminOptions;
			if ('closed' == $post->comment_status && !is_user_logged_in()) {
				return;
			}
			if (get_bloginfo('version') < "2.8") {
				wp_deregister_script(array('jquery'));
				wp_enqueue_script('jquery', $this->pluginDir . '/js/jquery-1.3.2.min.js');
			} else {
				wp_enqueue_script('jquery'); 
			}
			$min = '';
			if ($options['compressed_scripts'] == 'true') {
				$min = ".min";
			}
			//wp_deregister_script('colorbox');
			$load_footer = ($options['scripts_in_footer'] == "true" ? true: false);
			$this->load_frontend(false);
			wp_enqueue_script($this->colorboxScriptName, $this->pluginDir . "/js/jquery.colorbox{$min}.js", array("jquery"),'1.3.15',$load_footer);
			
			$this->js_localize('wpajaxeditcomments',$this->get_js_vars($post->ID));
			wp_enqueue_script('wp_ajax_edit_comments_script', $this->pluginDir . "/js/wp-ajax-edit-comments$min.js", array("jquery", "wp-ajax-response", $this->colorboxScriptName) , '4.0',$load_footer);
		} //end add_scripts
		//Loads the after-the-deadline scripts
		//Skips the page detection tests if $test = false
		function load_frontend($test = true) {
			if (is_admin()) { return; }
			$options = $this->adminOptions;
			$load_footer = ($options['scripts_in_footer'] == "true" ? true: false);
			if ($test == true) {
				if (!is_page() && !is_single())
					return;
				if ('closed' == $post->comment_status && !is_user_logged_in()) 
					return;
			}
			$min = '';
			if ($options['compressed_scripts'] == 'true') {
				$min = ".min";
			}
			$expand = ($options['expand_posts'] == 'true' ? true: false);
			$afterthedeadline = ($options['after_deadline_posts'] == "true" ? true : false);
			if (!$afterthedeadline) {
				$options['after_deadline_posts'] = 'false';
			}	
			if (!$expand && !$afterthedeadline)
				return;
			$aec_frontend = 	get_bloginfo('url') . '?aec_page=comment-popup.php';
			if ($this->adminOptions['use_wpload'])
				$aec_frontend = plugins_url('wp-ajax-edit-comments') . '/php/comment-popup.php';
			$this->js_localize('aec_frontend', array('atdlang' => $options['atdlang'], 'atd' => $options['after_deadline_posts'],'expand' => $options['expand_posts'],'url' => $aec_frontend, 'title' => __('Comment Box', $this->localizationName)));
			//After the deadline				
			if ($afterthedeadline) {
				wp_enqueue_script('atd', $this->pluginDir . "/js/jquery.atd.textarea.js", array("jquery") , "1.0", $load_footer);
				wp_enqueue_script('atd_hack', $this->pluginDir . '/js/csshttprequest.js', array('atd'), '1.0',$load_footer);
			} 
			if ($expand) {
				//wp_deregister_script('colorbox');
				wp_enqueue_script($this->colorboxScriptName, $this->pluginDir . "/js/jquery.colorbox{$min}.js", array("jquery"),'1.3.15',$load_footer);
			}
			if ($afterthedeadline && !$expand) {
				wp_enqueue_script('aec_frontend_init', $this->pluginDir . '/js/frontend.js', array(), '1.0',$load_footer);
			} elseif (!$afterthedeadline && $expand) {
				wp_enqueue_script('aec_frontend_init', $this->pluginDir . '/js/frontend.js', array($this->colorboxScriptName), '1.0',$load_footer);
			} else {
				wp_enqueue_script('aec_frontend_init', $this->pluginDir . '/js/frontend.js', array($this->colorboxScriptName, 'atd'), '1.0',$load_footer);
			}
		}
		//Loads the after-the-deadline scripts
		//Skips the page detection tests if $test = false
		function load_frontend_css() {
			if (is_admin()) { return; }
			$options = $this->adminOptions;
			global $post;
			if (!is_page() && !is_single())
					return;
			if ('closed' == $post->comment_status && !is_user_logged_in()) 
					return;
			
			$expand = ($options['expand_posts'] == 'true' ? true: false);
			$afterthedeadline = ($options['after_deadline_posts'] == "true" ? true : false);
			if (!$expand && !$afterthedeadline) 
				return;
				
			//After the deadline				
			if ($afterthedeadline) {
				wp_enqueue_style('atd', $this->pluginDir.'/css/atd/atd.css',array(),'1.0','screen');
			}
	
			if ($expand) {
				//wp_deregister_style('colorbox');
				wp_enqueue_style($this->colorboxStyleName, $this->pluginDir.'/css/colorbox/colorbox.css',array(),'1.0','screen');
			}
			wp_enqueue_style('aec_frontend', $this->pluginDir.'/css/frontend.css',array(),'1.0','screen');
		}
		//Localizes a script using function get_js_vars
		//Builds an object based on the passed $name variable
		function js_localize($name, $vars) {
			$data = "var $name = {";
			$arr = array();
			foreach ($vars as $key => $value) {
				$arr[count($arr)] = $key . " : '" . esc_js($value) . "'";
			}
			$data .= implode(",",$arr);
			$data .= "};";
			echo "<script type='text/javascript'>\n";
			echo "/* <![CDATA[ */\n";
			echo $data;
			echo "\n/* ]]> */\n";
			echo "</script>\n";
		}
		//Echoes out various JavaScript vars needed for the scripts
		function get_js_vars($postID) {
			$blogurl = get_bloginfo('url') . '/?aec_page=ajax-processor.php';
			if ($this->adminOptions['use_wpload'] == 'true')
				$blogurl = plugins_url('wp-ajax-edit-comments') . '/php/ajax-processor.php';
			return array(
				'AEC_BlogUrl' => $blogurl,
				'AEC_CanScroll' => $this->can_scroll($postID),
				'AEC_Minutes' => __('minutes', $this->localizationName),
				'AEC_Minute' => __('minute', $this->localizationName),
				'AEC_And' => __('and', $this->localizationName),
				'AEC_Seconds' => __('seconds', $this->localizationName),
				'AEC_Second' => __('second', $this->localizationName),
				'AEC_Moderation' => __('Mark for Moderation?', $this->localizationName), 
				'AEC_Approve' => __('Approve Comment?', $this->localizationName),
				'AEC_Spam' => __('Mark as Spam?', $this->localizationName), 
				'AEC_Delete' => __('Delete this comment?', $this->localizationName), 
				'AEC_Anon' => __('Anonymous', $this->localizationName), 
				'AEC_Loading' => __('Loading...', $this->localizationName),
				'AEC_Ready' => __('Ready', $this->localizationName),
				'AEC_Sending' => __('Sending...', $this->localizationName),
				'AEC_Sent' => __('Message Sent', $this->localizationName),
				'AEC_LoadSuccessful' => __('Comment Loaded Successfully', $this->localizationName), 
				'AEC_Saving' => __('Saving...', $this->localizationName), 
				'AEC_Blacklisting' => __('Blacklisting...', $this->localizationName), 
				'AEC_Saved' => __('Comment Successfully Saved', $this->localizationName), 
				'AEC_Delink' => __('De-link Successful', $this->localizationName),
				'AEC_MoreOptions' => __('More Options', $this->localizationName),
				'AEC_LessOptions' => __('Less Options', $this->localizationName),
				'AEC_UseRTL' => $this->adminOptions['use_rtl'],
				'AEC_RequestDeletionSuccess' => __('Request has been sent successfully', $this->localizationName),
				'AEC_RequestError' => __('Error sending request', $this->localizationName),
				'AEC_approving' => __('Approving...', $this->localizationName),
				'AEC_delinking' => __('De-linking...', $this->localizationName),
				'AEC_moderating' => __('Moderating...', $this->localizationName),
				'AEC_spamming' => __('Spamming...', $this->localizationName),
				'AEC_deleting' => __('Deleting...', $this->localizationName),
				'AEC_restoring' => __('Restoring...', $this->localizationName),
				'AEC_undoing' => __('Undoing...', $this->localizationName),
				'AEC_undosuccess' => __('Undo Successful', $this->localizationName),
				'AEC_permdelete' => __('Comment Deleted Permanently', $this->localizationName),
				'AEC_fieldsrequired' => __('Input Fields are Required', $this->localizationName),
				'AEC_emailaddresserror' => __('E-mail Address is Invalid', $this->localizationName),
				'AEC_AftertheDeadline' => ($this->adminOptions['after_deadline_popups'] == "true" ? 'true': 'false'),
				'AEC_AftertheDeadline_lang' => $this->adminOptions['atdlang'],
				'AEC_Expand' => ($this->adminOptions['expand_popups'] == "true" ? 'true': 'false'),
				'AEC_Yes' => __('Yes', $this->localizationName),
				'AEC_No' => __('No', $this->localizationName),
				'AEC_Sure' => __('Are you sure?', $this->localizationName)
			);
		} //end get_js_vars
		/**
		* Adds a link to the stylesheet to the header
		*/
		function add_css(){
			if (is_single() || is_page() || is_admin()) {
				if (is_page() && $this->adminOptions['show_pages'] != 'true') 
					return;

				switch ($this->adminOptions['icon_set']) {
					case "aesthetica-large":
					case "classy-large":
					case "shadow":
					case "moi":
						$iconSize = 24;
						break;
					default:
						$iconSize = 16;
						break;
					}
				wp_enqueue_style('aeceditcomments', $this->pluginDir.'/css/edit-comments.css.php?iconsize='.$iconSize.'&iconset='.$this->adminOptions['icon_set'].'&rtl='.$this->adminOptions['use_rtl'].'&icondisplay='.$this->adminOptions['icon_display'], array(), '4.1');
				/* From http://blue-anvil.com/archives/experiments-with-floats-whats-the-best-method-of-clearance */
				if ($this->adminOptions['clear_after'] == "true") { 
					wp_enqueue_style('aecclearfix', $this->pluginDir.'/css/clearfix.css', array('aeceditcomments'), '4.1');
					global $wp_styles;
					$wp_styles->add_data( 'aecclearfix', 'conditional', 'IE');
				} /* clear after */
				//After the deadline				
				if ($this->adminOptions['after_deadline'] == "true") {
					wp_enqueue_style('aecatd', $this->pluginDir.'/css/atd/atd.css', array(), '4.1');
				}
				wp_enqueue_style($this->colorboxStyleName, $this->pluginDir.'/css/colorbox/colorbox.css',array(),'1.0','screen');
			}
		}
		//Returns a random security key
		function random() {
		 $chars = "%CDEF#cGHIJ\:ab!@defg9ABhijklmn<>;opqrstuvwxyz10234/+_-=5678MKL^&*NOP";
		 $pass = '';
		 for ($i = 0; $i < 50; $i++) {
			$pass .= $chars{rand(0, strlen($chars)-1)};
		 }
		 return $pass;
		}
		/*END UTILITY FUNCTIONS*/
    }
}
//instantiate the class
if (class_exists('WPrapAjaxEditComments')) {
	if (get_bloginfo('version') >= "2.5") {
		$WPrapAjaxEditComments = new WPrapAjaxEditComments();
	}
}
//Template redirection stuff
add_action('template_redirect', 'aec_load_pages');
add_filter('query_vars', 'aec_query_triggers');
function aec_load_pages() {
	global $WPrapAjaxEditComments;
	$WPrapAjaxEditComments->load_pages();
}
function aec_query_triggers($vars) {
	global $WPrapAjaxEditComments;
	return $WPrapAjaxEditComments->add_query_triggers($vars);
}
?>